(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rete'), require('rete-render-utils'), require('@angular/core'), require('rete-area-plugin'), require('@angular/common'), require('@angular/elements')) :
    typeof define === 'function' && define.amd ? define('rete-angular-plugin', ['exports', 'rete', 'rete-render-utils', '@angular/core', 'rete-area-plugin', '@angular/common', '@angular/elements'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["rete-angular-plugin"] = {}, global.rete, global.reteRenderUtils, global.ng.core, global.reteAreaPlugin, global.ng.common, global.ng.elements));
})(this, (function (exports, rete, reteRenderUtils, core, reteAreaPlugin, common, elements) { 'use strict';

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __esDecorate(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
        function accept(f) { if (f !== void 0 && typeof f !== "function")
            throw new TypeError("Function expected"); return f; }
        var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
        var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
        var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
        var _, done = false;
        for (var i = decorators.length - 1; i >= 0; i--) {
            var context = {};
            for (var p in contextIn)
                context[p] = p === "access" ? {} : contextIn[p];
            for (var p in contextIn.access)
                context.access[p] = contextIn.access[p];
            context.addInitializer = function (f) { if (done)
                throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
            var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
            if (kind === "accessor") {
                if (result === void 0)
                    continue;
                if (result === null || typeof result !== "object")
                    throw new TypeError("Object expected");
                if (_ = accept(result.get))
                    descriptor.get = _;
                if (_ = accept(result.set))
                    descriptor.set = _;
                if (_ = accept(result.init))
                    initializers.push(_);
            }
            else if (_ = accept(result)) {
                if (kind === "field")
                    initializers.push(_);
                else
                    descriptor[key] = _;
            }
        }
        if (target)
            Object.defineProperty(target, contextIn.name, descriptor);
        done = true;
    }
    ;
    function __runInitializers(thisArg, initializers, value) {
        var useValue = arguments.length > 2;
        for (var i = 0; i < initializers.length; i++) {
            value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
        }
        return useValue ? value : void 0;
    }
    ;
    function __propKey(x) {
        return typeof x === "symbol" ? x : "".concat(x);
    }
    ;
    function __setFunctionName(f, name, prefix) {
        if (typeof name === "symbol")
            name = name.description ? "[".concat(name.description, "]") : "";
        return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
    }
    ;
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (g && (g = 0, op[0] && (_ = 0)), _)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        var desc = Object.getOwnPropertyDescriptor(m, k);
        if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
            desc = { enumerable: true, get: function () { return m[k]; } };
        }
        Object.defineProperty(o, k2, desc);
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }
    function __classPrivateFieldIn(state, receiver) {
        if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function"))
            throw new TypeError("Cannot use 'in' operator on non-object");
        return typeof state === "function" ? receiver === state : state.has(receiver);
    }

    var NodeComponent = /** @class */ (function () {
        function NodeComponent(cdr) {
            this.cdr = cdr;
            this.seed = 0;
            this.cdr.detach();
        }
        Object.defineProperty(NodeComponent.prototype, "width", {
            get: function () {
                return this.data.width;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NodeComponent.prototype, "height", {
            get: function () {
                return this.data.height;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NodeComponent.prototype, "selected", {
            get: function () {
                return this.data.selected;
            },
            enumerable: false,
            configurable: true
        });
        NodeComponent.prototype.ngOnChanges = function () {
            var _this = this;
            this.cdr.detectChanges();
            requestAnimationFrame(function () { return _this.rendered(); });
            this.seed++; // force render sockets
        };
        NodeComponent.prototype.sortByIndex = function (a, b) {
            var _a, _b;
            var ai = ((_a = a.value) === null || _a === void 0 ? void 0 : _a.index) || 0;
            var bi = ((_b = b.value) === null || _b === void 0 ? void 0 : _b.index) || 0;
            return ai - bi;
        };
        return NodeComponent;
    }());
    NodeComponent.decorators = [
        { type: core.Component, args: [{
                    // [component-directive]
                    template: "<div class=\"title\" data-testid=\"title\">{{data.label}}</div>\n<div class=\"output\" *ngFor=\"let output of data.outputs | keyvalue: sortByIndex\" [attr.data-testid]=\"'output-'+output.key\">\n    <div class=\"output-title\" data-testid=\"output-title\">{{output.value?.label}}</div>\n    <div\n        class=\"output-socket\"\n        refComponent\n        [data]=\"{type: 'socket', side: 'output', key: output.key, nodeId: data.id, payload: output.value?.socket, seed: seed }\"\n        [emit]=\"emit\"\n        data-testid=\"output-socket\"\n    ></div>\n</div>\n<div\n    class=\"control\"\n    *ngFor=\"let control of data.controls | keyvalue: sortByIndex\"\n    refComponent\n    [data]=\"{type: 'control', payload: control.value }\"\n    [emit]=\"emit\"\n    [attr.data-testid]=\"'control-'+control.key\"\n></div>\n<div class=\"input\" *ngFor=\"let input of data.inputs | keyvalue: sortByIndex\" [attr.data-testid]=\"'input-'+input.key\">\n    <div\n        class=\"input-socket\"\n        refComponent\n        [data]=\"{type: 'socket', side: 'input', key: input.key, nodeId: data.id, payload: input.value?.socket, seed: seed }\"\n        [emit]=\"emit\"\n        data-testid=\"input-socket\"\n    ></div>\n    <div class=\"input-title\" data-testid=\"input-title\" *ngIf=\"!input.value?.control || !input.value?.showControl\">{{input.value?.label}}</div>\n    <div\n        class=\"input-control\"\n        [style.display]=\"input.value?.control && input.value?.showControl ? '' : 'none'\"\n        refComponent\n        [data]=\"{type: 'control', payload: input.value?.control }\"\n        [emit]=\"emit\"\n        data-testid=\"input-control\"\n    ></div>\n</div>\n",
                    host: {
                        'data-testid': 'node'
                    },
                    styles: [":host{display:block;background:rgba(110,136,255,.8);border:2px solid #4e58bf;border-radius:10px;cursor:pointer;box-sizing:border-box;width:180px;height:auto;padding-bottom:6px;position:relative;-webkit-user-select:none;user-select:none;line-height:initial;font-family:Arial}:host:hover{background:rgba(130,153,255,.8)}:host.selected{background:#ffd92c;border-color:#e3c000}:host .title{color:#fff;font-family:sans-serif;font-size:18px;padding:8px}:host .output{text-align:right}:host .input{text-align:left}:host .input-title,:host .output-title{vertical-align:middle;color:#fff;display:inline-block;font-family:sans-serif;font-size:14px;margin:6px;line-height:24px}:host .input-title[hidden],:host .output-title[hidden]{display:none}:host .output-socket{text-align:right;margin-right:-18px;display:inline-block}:host .input-socket{text-align:left;margin-left:-18px;display:inline-block}:host .input-control{z-index:1;width:calc(100% - 36px);vertical-align:middle;display:inline-block}:host .control{padding:6px 18px}\n"]
                },] }
    ];
    NodeComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    NodeComponent.propDecorators = {
        data: [{ type: core.Input }],
        emit: [{ type: core.Input }],
        rendered: [{ type: core.Input }],
        width: [{ type: core.HostBinding, args: ['style.width.px',] }],
        height: [{ type: core.HostBinding, args: ['style.height.px',] }],
        selected: [{ type: core.HostBinding, args: ['class.selected',] }]
    };

    var SocketComponent = /** @class */ (function () {
        function SocketComponent(cdr) {
            this.cdr = cdr;
            this.cdr.detach();
        }
        Object.defineProperty(SocketComponent.prototype, "title", {
            get: function () {
                return this.data.name;
            },
            enumerable: false,
            configurable: true
        });
        SocketComponent.prototype.ngOnChanges = function () {
            var _this = this;
            this.cdr.detectChanges();
            requestAnimationFrame(function () { return _this.rendered(); });
        };
        return SocketComponent;
    }());
    SocketComponent.decorators = [
        { type: core.Component, args: [{
                    template: "",
                    styles: [":host{display:inline-block;cursor:pointer;border:1px solid white;border-radius:12px;width:24px;height:24px;margin:6px;vertical-align:middle;background:#96b38a;z-index:2;box-sizing:border-box}:host:hover{border-width:4px}:host.multiple{border-color:#ff0}:host.output{margin-right:-12px}:host.input{margin-left:-12px}\n"]
                },] }
    ];
    SocketComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    SocketComponent.propDecorators = {
        data: [{ type: core.Input }],
        rendered: [{ type: core.Input }],
        title: [{ type: core.HostBinding, args: ['title',] }]
    };

    var ControlComponent = /** @class */ (function () {
        function ControlComponent(cdr) {
            this.cdr = cdr;
            this.cdr.detach();
        }
        ControlComponent.prototype.pointerdown = function (event) {
            event.stopPropagation();
        };
        ControlComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            var seed = changes['seed'];
            var data = changes['data'];
            if ((seed && seed.currentValue !== seed.previousValue)
                || (data && data.currentValue !== data.previousValue)) {
                this.cdr.detectChanges();
            }
            requestAnimationFrame(function () { return _this.rendered(); });
        };
        ControlComponent.prototype.onChange = function (e) {
            var target = e.target;
            var value = (this.data.type === 'number'
                ? +target.value
                : target.value);
            this.data.setValue(value);
            this.cdr.detectChanges();
        };
        return ControlComponent;
    }());
    ControlComponent.decorators = [
        { type: core.Component, args: [{
                    template: "<input\n  [value]=\"data.value\"\n  [readonly]=\"data.readonly\"\n  [type]=\"data.type\"\n  (input)=\"onChange($event)\"\n/>\n",
                    styles: ["input{width:100%;border-radius:30px;background-color:#fff;padding:2px 6px;border:1px solid #999;font-size:110%;box-sizing:border-box}\n"]
                },] }
    ];
    ControlComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    ControlComponent.propDecorators = {
        data: [{ type: core.Input }],
        rendered: [{ type: core.Input }],
        pointerdown: [{ type: core.HostListener, args: ['pointerdown', ['$event'],] }]
    };

    var ConnectionComponent = /** @class */ (function () {
        function ConnectionComponent() {
        }
        return ConnectionComponent;
    }());
    ConnectionComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'connection',
                    template: "<svg data-testid=\"connection\">\n    <path [attr.d]=\"path\" />\n</svg>\n",
                    styles: ["svg{overflow:visible!important;position:absolute;pointer-events:none;width:9999px;height:9999px}svg path{fill:none;stroke-width:5px;stroke:#4682b4;pointer-events:auto}\n"]
                },] }
    ];
    ConnectionComponent.propDecorators = {
        data: [{ type: core.Input }],
        start: [{ type: core.Input }],
        end: [{ type: core.Input }],
        path: [{ type: core.Input }]
    };

    var ConnectionWrapperComponent = /** @class */ (function () {
        function ConnectionWrapperComponent(cdr, viewContainerRef, componentFactoryResolver) {
            this.cdr = cdr;
            this.viewContainerRef = viewContainerRef;
            this.componentFactoryResolver = componentFactoryResolver;
            this.startOb = null;
            this.endOb = null;
            this.cdr.detach();
        }
        Object.defineProperty(ConnectionWrapperComponent.prototype, "_start", {
            get: function () {
                return 'x' in this.start ? this.start : this.startOb;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ConnectionWrapperComponent.prototype, "_end", {
            get: function () {
                return 'x' in this.end ? this.end : this.endOb;
            },
            enumerable: false,
            configurable: true
        });
        ConnectionWrapperComponent.prototype.ngOnChanges = function () {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.updatePath()];
                        case 1:
                            _a.sent();
                            requestAnimationFrame(function () { return _this.rendered(); });
                            this.cdr.detectChanges();
                            this.update();
                            return [2 /*return*/];
                    }
                });
            });
        };
        ConnectionWrapperComponent.prototype.updatePath = function () {
            return __awaiter(this, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            if (!(this._start && this._end)) return [3 /*break*/, 2];
                            _a = this;
                            return [4 /*yield*/, this.path(this._start, this._end)];
                        case 1:
                            _a._path = _b.sent();
                            _b.label = 2;
                        case 2: return [2 /*return*/];
                    }
                });
            });
        };
        ConnectionWrapperComponent.prototype.ngOnInit = function () {
            var _this = this;
            if (typeof this.start === 'function') {
                this.start(function (value) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                this.startOb = value;
                                return [4 /*yield*/, this.updatePath()];
                            case 1:
                                _a.sent();
                                this.cdr.detectChanges();
                                this.update();
                                return [2 /*return*/];
                        }
                    });
                }); });
            }
            if (typeof this.end === 'function') {
                this.end(function (value) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                this.endOb = value;
                                return [4 /*yield*/, this.updatePath()];
                            case 1:
                                _a.sent();
                                this.cdr.detectChanges();
                                this.update();
                                return [2 /*return*/];
                        }
                    });
                }); });
            }
            var componentFactory = this.componentFactoryResolver.resolveComponentFactory(this.connectionComponent);
            this.viewContainerRef.clear();
            this.ref = this.viewContainerRef.createComponent(componentFactory);
            this.update();
        };
        ConnectionWrapperComponent.prototype.update = function () {
            this.ref.instance.data = this.data;
            this.ref.instance.start = this._start;
            this.ref.instance.end = this._end;
            this.ref.instance.path = this._path;
        };
        return ConnectionWrapperComponent;
    }());
    ConnectionWrapperComponent.decorators = [
        { type: core.Component, args: [{
                    template: ''
                },] }
    ];
    ConnectionWrapperComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: core.ViewContainerRef },
        { type: core.ComponentFactoryResolver }
    ]; };
    ConnectionWrapperComponent.propDecorators = {
        data: [{ type: core.Input }],
        start: [{ type: core.Input }],
        end: [{ type: core.Input }],
        path: [{ type: core.Input }],
        rendered: [{ type: core.Input }],
        connectionComponent: [{ type: core.Input }]
    };

    /**
     * Classic preset for rendering nodes, connections, controls and sockets.
     */
    function setup$3(props) {
        var positionWatcher = typeof (props === null || props === void 0 ? void 0 : props.socketPositionWatcher) === 'undefined'
            ? reteRenderUtils.getDOMSocketPosition() // fix Type instantiation is excessively deep and possibly infinite.
            : props === null || props === void 0 ? void 0 : props.socketPositionWatcher;
        var _a = (props === null || props === void 0 ? void 0 : props.customize) || {}, node = _a.node, connection = _a.connection, socket = _a.socket, control = _a.control;
        return {
            attach: function (plugin) {
                positionWatcher.attach(plugin);
            },
            update: function (context) {
                var data = context.data.payload;
                if (context.data.type === 'connection') {
                    var _a = context.data, start = _a.start, end = _a.end;
                    return Object.assign(Object.assign({ data: data }, (start ? { start: start } : {})), (end ? { end: end } : {}));
                }
                return { data: data };
            },
            mount: function (context, plugin) {
                var _this = this;
                var parent = plugin.parentScope();
                var emit = parent.emit.bind(parent);
                var rendered = function () {
                    emit({ type: 'rendered', data: context.data });
                };
                if (context.data.type === 'node') {
                    var component = node ? node(context.data) : NodeComponent;
                    return {
                        key: "node-" + context.data.payload.id,
                        component: component,
                        props: {
                            data: context.data.payload,
                            emit: emit,
                            rendered: rendered
                        }
                    };
                }
                if (context.data.type === 'connection') {
                    var component = connection ? connection(context.data) : ConnectionComponent;
                    var id = context.data.payload.id;
                    var _a = context.data.payload, sourceOutput_1 = _a.sourceOutput, targetInput_1 = _a.targetInput, source_1 = _a.source, target_1 = _a.target;
                    var _b = context.data, start = _b.start, end = _b.end, payload_1 = _b.payload;
                    return {
                        key: "connection-" + id,
                        component: ConnectionWrapperComponent,
                        props: {
                            connectionComponent: component,
                            data: payload_1,
                            start: start || (function (change) { return positionWatcher.listen(source_1, 'output', sourceOutput_1, change); }),
                            end: end || (function (change) { return positionWatcher.listen(target_1, 'input', targetInput_1, change); }),
                            path: function (start, end) { return __awaiter(_this, void 0, void 0, function () {
                                var response, _a, path, points, curvature;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0: return [4 /*yield*/, plugin.emit({ type: 'connectionpath', data: { payload: payload_1, points: [start, end] } })];
                                        case 1:
                                            response = _b.sent();
                                            if (!response)
                                                return [2 /*return*/, ''];
                                            _a = response.data, path = _a.path, points = _a.points;
                                            curvature = 0.3;
                                            if (!path && points.length !== 2)
                                                throw new Error('cannot render connection with a custom number of points');
                                            if (!path)
                                                return [2 /*return*/, payload_1.isLoop
                                                        ? reteRenderUtils.loopConnectionPath(points, curvature, 120)
                                                        : reteRenderUtils.classicConnectionPath(points, curvature)];
                                            return [2 /*return*/, path];
                                    }
                                });
                            }); },
                            rendered: rendered
                        }
                    };
                }
                if (context.data.type === 'socket') {
                    var component = socket ? socket(context.data) : SocketComponent;
                    return {
                        key: "socket-" + rete.getUID(),
                        component: component,
                        props: {
                            data: context.data.payload,
                            rendered: rendered
                        }
                    };
                }
                if (context.data.type === 'control') {
                    var component = control
                        ? control(context.data)
                        : (context.data.payload instanceof rete.ClassicPreset.InputControl
                            ? ControlComponent
                            : null);
                    if (component) {
                        return {
                            key: "control-" + context.data.payload.id,
                            component: component,
                            props: {
                                data: context.data.payload,
                                rendered: rendered
                            }
                        };
                    }
                    return;
                }
                return;
            }
        };
    }

    var index$4 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        setup: setup$3
    });

    function debounce(cb) {
        return {
            timeout: null,
            cancel: function () {
                if (this.timeout) {
                    window.clearTimeout(this.timeout);
                    this.timeout = null;
                }
            },
            call: function (delay) {
                this.timeout = window.setTimeout(function () {
                    cb();
                }, delay);
            }
        };
    }

    // [imports]
    var ContextMenuComponent = /** @class */ (function () {
        function ContextMenuComponent(cdr) {
            var _this = this;
            this.cdr = cdr;
            this.filter = '';
            this.hide = debounce(function () {
                _this.onHide();
                _this.cdr.detectChanges();
            });
            this.customAttribute = '';
            this.cdr.detach();
        }
        ContextMenuComponent.prototype.pointerover = function () {
            this.hide.cancel();
            this.cdr.detectChanges();
        };
        ContextMenuComponent.prototype.pointerleave = function () {
            this.hide.call(this.delay);
            this.cdr.detectChanges();
        };
        ContextMenuComponent.prototype.ngOnChanges = function () {
            var _this = this;
            this.cdr.detectChanges();
            requestAnimationFrame(function () { return _this.rendered(); });
        };
        ContextMenuComponent.prototype.setFilter = function (value) {
            this.filter = value;
            this.cdr.detectChanges();
        };
        ContextMenuComponent.prototype.getItems = function () {
            var filterRegexp = new RegExp(this.filter, 'i');
            var filteredList = this.items.filter(function (item) { return (item.label.match(filterRegexp)); });
            return filteredList;
        };
        ContextMenuComponent.prototype.ngOnDestroy = function () {
            if (this.hide)
                this.hide.cancel();
        };
        return ContextMenuComponent;
    }());
    ContextMenuComponent.decorators = [
        { type: core.Component, args: [{
                    // [component-directive]
                    template: "<div class=\"block\" *ngIf=\"searchBar\">\n  <context-menu-search [value]=\"filter\" (update)=\"setFilter($event)\"></context-menu-search>\n</div>\n\n<context-menu-item *ngFor=\"let item of getItems()\" [delay]=\"delay\" (select)=\"item.handler()\" [subitems]=\"item.subitems\"\n  (hide)=\"onHide()\">\n  {{ item.label }}\n</context-menu-item>\n",
                    host: {
                        'data-testid': 'context-menu'
                    },
                    styles: [":host{display:block;padding:10px;width:120px;margin-top:-20px;margin-left:-60px}\n", ".block{display:block;color:#fff;padding:4px;border-bottom:1px solid rgba(69,103,255,.8);background-color:#6e88ffcc;cursor:pointer;width:100%;position:relative}.block:first-child{border-top-left-radius:5px;border-top-right-radius:5px}.block:last-child{border-bottom-left-radius:5px;border-bottom-right-radius:5px}.block:hover{background-color:#8299ffcc}\n"]
                },] }
    ];
    ContextMenuComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    ContextMenuComponent.propDecorators = {
        items: [{ type: core.Input }],
        delay: [{ type: core.Input }],
        searchBar: [{ type: core.Input }],
        onHide: [{ type: core.Input }],
        rendered: [{ type: core.Input }],
        customAttribute: [{ type: core.HostBinding, args: ['attr.rete-context-menu',] }],
        pointerover: [{ type: core.HostListener, args: ['mouseover',] }],
        pointerleave: [{ type: core.HostListener, args: ['mouseleave',] }]
    };

    /**
     * Preset for rendering context menu.
     */
    function setup$2(props) {
        var delay = typeof (props === null || props === void 0 ? void 0 : props.delay) === 'undefined' ? 1000 : props.delay;
        return {
            update: function (context) {
                if (context.data.type === 'contextmenu') {
                    return {
                        items: context.data.items,
                        delay: delay,
                        searchBar: context.data.searchBar,
                        onHide: context.data.onHide
                    };
                }
            },
            mount: function (context, plugin) {
                var parent = plugin.parentScope();
                var emit = parent.emit.bind(parent);
                var rendered = function () {
                    emit({ type: 'rendered', data: context.data });
                };
                if (context.data.type === 'contextmenu') {
                    return {
                        key: 'context-menu',
                        component: ContextMenuComponent,
                        props: {
                            items: context.data.items,
                            delay: delay,
                            searchBar: context.data.searchBar,
                            onHide: context.data.onHide,
                            rendered: rendered
                        }
                    };
                }
                return null;
            }
        };
    }

    var index$3 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        setup: setup$2
    });

    // [imports]
    var MinimapComponent = /** @class */ (function () {
        function MinimapComponent(el, cdr) {
            this.el = el;
            this.cdr = cdr;
            this.cdr.detach();
        }
        Object.defineProperty(MinimapComponent.prototype, "width", {
            get: function () {
                return this.px(this.size * this.ratio);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MinimapComponent.prototype, "height", {
            get: function () {
                return this.px(this.size);
            },
            enumerable: false,
            configurable: true
        });
        MinimapComponent.prototype.pointerdown = function (event) {
            event.stopPropagation();
            event.preventDefault();
        };
        MinimapComponent.prototype.dblclick = function (event) {
            event.stopPropagation();
            event.preventDefault();
            if (!this.el.nativeElement)
                return;
            var box = this.el.nativeElement.getBoundingClientRect();
            var x = (event.clientX - box.left) / (this.size * this.ratio);
            var y = (event.clientY - box.top) / (this.size * this.ratio);
            this.point(x, y);
        };
        MinimapComponent.prototype.ngOnChanges = function () {
            var _this = this;
            this.cdr.detectChanges();
            requestAnimationFrame(function () { return _this.rendered(); });
        };
        MinimapComponent.prototype.px = function (value) {
            return value + "px";
        };
        MinimapComponent.prototype.scale = function (value) {
            if (!this.el.nativeElement)
                return 0;
            return value * this.el.nativeElement.clientWidth;
        };
        MinimapComponent.prototype.identifyMiniNode = function (_, item) {
            return [item.top, item.left].join('_');
        };
        return MinimapComponent;
    }());
    MinimapComponent.decorators = [
        { type: core.Component, args: [{
                    // [component-directive]
                    template: "<minimap-mini-node *ngFor=\"let node of nodes; trackBy: identifyMiniNode\" [left]=\"scale(node.left)\"\n  [top]=\"scale(node.top)\" [width]=\"scale(node.width)\" [height]=\"scale(node.height)\">\n\n</minimap-mini-node>\n<minimap-mini-viewport [left]=\"viewport.left\" [top]=\"viewport.top\" [width]=\"viewport.width\" [height]=\"viewport.height\"\n  [containerWidth]=\"el.nativeElement?.clientWidth\" [translate]=\"translate\"></minimap-mini-viewport>\n",
                    host: {
                        'data-testid': 'minimap'
                    },
                    styles: [":host{position:absolute;right:24px;bottom:24px;background:rgba(229,234,239,.65);padding:20px;overflow:hidden;border:1px solid #b1b7ff;border-radius:8px;box-sizing:border-box}\n"]
                },] }
    ];
    MinimapComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.ChangeDetectorRef }
    ]; };
    MinimapComponent.propDecorators = {
        rendered: [{ type: core.Input }],
        size: [{ type: core.Input }],
        ratio: [{ type: core.Input }],
        nodes: [{ type: core.Input }],
        viewport: [{ type: core.Input }],
        translate: [{ type: core.Input }],
        point: [{ type: core.Input }],
        width: [{ type: core.HostBinding, args: ['style.width',] }],
        height: [{ type: core.HostBinding, args: ['style.height',] }],
        pointerdown: [{ type: core.HostListener, args: ['pointerdown', ['$event'],] }],
        dblclick: [{ type: core.HostListener, args: ['dblclick', ['$event'],] }]
    };

    /**
     * Preset for rendering minimap.
     */
    function setup$1(props) {
        return {
            update: function (context) {
                if (context.data.type === 'minimap') {
                    return {
                        nodes: context.data.nodes,
                        size: (props === null || props === void 0 ? void 0 : props.size) || 200,
                        ratio: context.data.ratio,
                        viewport: context.data.viewport,
                        translate: context.data.translate,
                        point: context.data.point
                    };
                }
                return null;
            },
            mount: function (context, plugin) {
                var parent = plugin.parentScope();
                var emit = parent.emit.bind(parent);
                var rendered = function () {
                    emit({ type: 'rendered', data: context.data });
                };
                if (context.data.type === 'minimap') {
                    return {
                        key: 'rete-minimap',
                        component: MinimapComponent,
                        props: {
                            nodes: context.data.nodes,
                            size: (props === null || props === void 0 ? void 0 : props.size) || 200,
                            ratio: context.data.ratio,
                            viewport: context.data.viewport,
                            translate: context.data.translate,
                            point: context.data.point,
                            rendered: rendered
                        }
                    };
                }
                return null;
            }
        };
    }

    var index$2 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        setup: setup$1
    });

    // [imports]
    var PinsComponent = /** @class */ (function () {
        function PinsComponent(cdr) {
            this.cdr = cdr;
            this.cdr.detach();
        }
        PinsComponent.prototype.ngOnChanges = function () {
            var _this = this;
            this.cdr.detectChanges();
            requestAnimationFrame(function () { return _this.rendered(); });
        };
        PinsComponent.prototype.track = function (_, item) {
            return item.id;
        };
        return PinsComponent;
    }());
    PinsComponent.decorators = [
        { type: core.Component, args: [{
                    // [component-directive]
                    template: "<reroute-pin *ngFor=\"let pin of pins; trackBy: track\" [position]=\"pin.position\" [selected]=\"pin.selected\"\n  (menu)=\"menu && menu(pin.id)\" (translate)=\"translate && translate(pin.id, $event.dx, $event.dy)\"\n  (down)=\"down && down(pin.id)\" [getPointer]=\"getPointer\"></reroute-pin>\n"
                },] }
    ];
    PinsComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    PinsComponent.propDecorators = {
        rendered: [{ type: core.Input }],
        pins: [{ type: core.Input }],
        down: [{ type: core.Input }],
        translate: [{ type: core.Input }],
        menu: [{ type: core.Input }],
        getPointer: [{ type: core.Input }]
    };

    /**
     * Preset for rendering pins.
     */
    function setup(props) {
        var getProps = function () { return ({
            menu: (props === null || props === void 0 ? void 0 : props.contextMenu) || (function () { return null; }),
            translate: (props === null || props === void 0 ? void 0 : props.translate) || (function () { return null; }),
            down: (props === null || props === void 0 ? void 0 : props.pointerdown) || (function () { return null; })
        }); };
        return {
            update: function (context) {
                if (context.data.type === 'reroute-pins') {
                    return Object.assign(Object.assign({}, getProps()), { pins: context.data.data.pins });
                }
                return null;
            },
            mount: function (context, plugin) {
                var area = plugin.parentScope(reteAreaPlugin.BaseAreaPlugin);
                var rendered = function () {
                    area.emit({ type: 'rendered', data: context.data });
                };
                if (context.data.type === 'reroute-pins') {
                    return {
                        key: 'rete-reroute',
                        component: PinsComponent,
                        props: Object.assign(Object.assign({}, getProps()), { pins: context.data.data.pins, rendered: rendered, getPointer: function () { return area.area.pointer; } })
                    };
                }
                return null;
            }
        };
    }

    var index$1 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        setup: setup
    });

    var index = /*#__PURE__*/Object.freeze({
        __proto__: null,
        classic: index$4,
        contextMenu: index$3,
        minimap: index$2,
        reroute: index$1
    });

    var RefDirective = /** @class */ (function () {
        function RefDirective(el) {
            this.el = el;
        }
        RefDirective.prototype.ngOnChanges = function () {
            this.emit({ type: 'render', data: Object.assign(Object.assign({}, this.data), { element: this.el.nativeElement }) });
        };
        RefDirective.prototype.ngOnDestroy = function () {
            this.emit({ type: 'unmount', data: { element: this.el.nativeElement } });
        };
        return RefDirective;
    }());
    RefDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[refComponent]'
                },] }
    ];
    RefDirective.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };
    RefDirective.propDecorators = {
        data: [{ type: core.Input }],
        emit: [{ type: core.Input }]
    };

    var ReteModule = /** @class */ (function () {
        function ReteModule() {
        }
        return ReteModule;
    }());
    ReteModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        RefDirective,
                        NodeComponent,
                        ConnectionComponent,
                        ConnectionWrapperComponent,
                        SocketComponent,
                        ControlComponent
                    ],
                    imports: [
                        common.CommonModule
                    ],
                    exports: [
                        RefDirective,
                        NodeComponent,
                        ConnectionComponent,
                        ConnectionWrapperComponent,
                        SocketComponent,
                        ControlComponent
                    ],
                    entryComponents: [
                        NodeComponent,
                        ConnectionComponent,
                        ConnectionWrapperComponent,
                        SocketComponent,
                        ControlComponent
                    ]
                },] }
    ];

    var ContextMenuSearchComponent = /** @class */ (function () {
        function ContextMenuSearchComponent() {
            this.update = new core.EventEmitter();
        }
        return ContextMenuSearchComponent;
    }());
    ContextMenuSearchComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'context-menu-search',
                    template: "<input class=\"search\" [value]=\"value\" (input)=\"update.emit($any($event.target)?.value || '')\"\n  data-testid=\"context-menu-search-input\" />\n",
                    styles: [".search{color:#fff;padding:1px 8px;border:1px solid white;border-radius:10px;font-size:16px;font-family:serif;width:100%;box-sizing:border-box;background:transparent}\n"]
                },] }
    ];
    ContextMenuSearchComponent.propDecorators = {
        value: [{ type: core.Input }],
        update: [{ type: core.Output }]
    };

    // [imports]
    var ContextMenuItemComponent = /** @class */ (function () {
        function ContextMenuItemComponent(cdr) {
            var _this = this;
            this.cdr = cdr;
            this.select = new core.EventEmitter();
            this.hide = new core.EventEmitter();
            this.hideSubitems = debounce(function () {
                _this.visibleSubitems = false;
                _this.cdr.detectChanges();
            });
            this.visibleSubitems = false;
            this.cdr.detach();
        }
        Object.defineProperty(ContextMenuItemComponent.prototype, "block", {
            get: function () { return true; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ContextMenuItemComponent.prototype, "hasSubitems", {
            get: function () { return this.subitems; },
            enumerable: false,
            configurable: true
        });
        ContextMenuItemComponent.prototype.click = function (event) {
            event.stopPropagation();
            this.select.emit();
            this.hide.emit();
        };
        ContextMenuItemComponent.prototype.pointerdown = function (event) {
            event.stopPropagation();
        };
        ContextMenuItemComponent.prototype.wheel = function (event) {
            event.stopPropagation();
        };
        ContextMenuItemComponent.prototype.pointerover = function () {
            this.hideSubitems.cancel();
            this.visibleSubitems = true;
            this.cdr.detectChanges();
        };
        ContextMenuItemComponent.prototype.pointerleave = function () {
            this.hideSubitems.call(this.delay);
            this.cdr.detectChanges();
        };
        return ContextMenuItemComponent;
    }());
    ContextMenuItemComponent.decorators = [
        { type: core.Component, args: [{
                    // [component-directive]
                    selector: 'context-menu-item',
                    template: "<ng-content></ng-content>\n<div class=\"subitems\" *ngIf=\"subitems && visibleSubitems\">\n  <context-menu-item *ngFor=\"let item of subitems\" [delay]=\"delay\" (select)=\"item.handler()\" (hide)=\"hide.emit()\">\n    {{ item.label }}\n  </context-menu-item>\n</div>\n",
                    host: {
                        'data-testid': 'context-menu-item'
                    },
                    styles: ["@charset \"UTF-8\";:host(.hasSubitems):after{content:\"\\25ba\";position:absolute;opacity:.6;right:5px;top:5px;font-family:initial}.subitems{position:absolute;top:0;left:100%;width:120px}\n", ".block{display:block;color:#fff;padding:4px;border-bottom:1px solid rgba(69,103,255,.8);background-color:#6e88ffcc;cursor:pointer;width:100%;position:relative}.block:first-child{border-top-left-radius:5px;border-top-right-radius:5px}.block:last-child{border-bottom-left-radius:5px;border-bottom-right-radius:5px}.block:hover{background-color:#8299ffcc}\n"]
                },] }
    ];
    ContextMenuItemComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    ContextMenuItemComponent.propDecorators = {
        subitems: [{ type: core.Input }],
        delay: [{ type: core.Input }],
        select: [{ type: core.Output }],
        hide: [{ type: core.Output }],
        block: [{ type: core.HostBinding, args: ['class.block',] }],
        hasSubitems: [{ type: core.HostBinding, args: ['class.hasSubitems',] }],
        click: [{ type: core.HostListener, args: ['click', ['$event'],] }],
        pointerdown: [{ type: core.HostListener, args: ['pointerdown', ['$event'],] }],
        wheel: [{ type: core.HostListener, args: ['wheel', ['$event'],] }],
        pointerover: [{ type: core.HostListener, args: ['pointerover',] }],
        pointerleave: [{ type: core.HostListener, args: ['pointerleave',] }]
    };

    var ReteContextMenuModule = /** @class */ (function () {
        function ReteContextMenuModule() {
        }
        return ReteContextMenuModule;
    }());
    ReteContextMenuModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        ContextMenuComponent,
                        ContextMenuSearchComponent,
                        ContextMenuItemComponent
                    ],
                    imports: [
                        common.CommonModule
                    ],
                    exports: [
                        ContextMenuComponent,
                        ContextMenuSearchComponent,
                        ContextMenuItemComponent,
                    ],
                    entryComponents: [
                        ContextMenuComponent
                    ]
                },] }
    ];

    function useDrag(translate, getPointer) {
        return {
            start: function (e) {
                var previous = Object.assign({}, getPointer(e));
                function move(moveEvent) {
                    var current = Object.assign({}, getPointer(moveEvent));
                    var dx = current.x - previous.x;
                    var dy = current.y - previous.y;
                    previous = current;
                    translate(dx, dy);
                }
                function up() {
                    window.removeEventListener('pointermove', move);
                    window.removeEventListener('pointerup', up);
                    window.removeEventListener('pointercancel', up);
                }
                window.addEventListener('pointermove', move);
                window.addEventListener('pointerup', up);
                window.addEventListener('pointercancel', up);
            }
        };
    }

    var MiniViewportComponent = /** @class */ (function () {
        function MiniViewportComponent() {
            var _this = this;
            this.drag = useDrag(function (dx, dy) { return _this.onDrag(dx, dy); }, function (e) { return ({ x: e.pageX, y: e.pageY }); });
        }
        Object.defineProperty(MiniViewportComponent.prototype, "styleLeft", {
            get: function () {
                return this.px(this.scale(this.left));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MiniViewportComponent.prototype, "styleTop", {
            get: function () {
                return this.px(this.scale(this.top));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MiniViewportComponent.prototype, "styleWidth", {
            get: function () {
                return this.px(this.scale(this.width));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MiniViewportComponent.prototype, "styleHeight", {
            get: function () {
                return this.px(this.scale(this.height));
            },
            enumerable: false,
            configurable: true
        });
        MiniViewportComponent.prototype.pointerdown = function (event) {
            event.stopPropagation();
            this.drag.start(event);
        };
        MiniViewportComponent.prototype.px = function (value) {
            return value + "px";
        };
        MiniViewportComponent.prototype.scale = function (v) {
            return v * this.containerWidth;
        };
        MiniViewportComponent.prototype.invert = function (v) {
            return v / this.containerWidth;
        };
        MiniViewportComponent.prototype.onDrag = function (dx, dy) {
            this.translate(this.invert(-dx), this.invert(-dy));
        };
        return MiniViewportComponent;
    }());
    MiniViewportComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'minimap-mini-viewport',
                    template: "",
                    host: {
                        'data-testid': 'minimap-viewport'
                    },
                    styles: [":host{display:block;position:absolute;background:rgba(255,251,128,.32);border:1px solid #ffe52b}\n"]
                },] }
    ];
    MiniViewportComponent.propDecorators = {
        left: [{ type: core.Input }],
        top: [{ type: core.Input }],
        width: [{ type: core.Input }],
        height: [{ type: core.Input }],
        containerWidth: [{ type: core.Input }],
        translate: [{ type: core.Input }],
        styleLeft: [{ type: core.HostBinding, args: ['style.left',] }],
        styleTop: [{ type: core.HostBinding, args: ['style.top',] }],
        styleWidth: [{ type: core.HostBinding, args: ['style.width',] }],
        styleHeight: [{ type: core.HostBinding, args: ['style.height',] }],
        pointerdown: [{ type: core.HostListener, args: ['pointerdown', ['$event'],] }]
    };

    var MiniNodeComponent = /** @class */ (function () {
        function MiniNodeComponent() {
        }
        Object.defineProperty(MiniNodeComponent.prototype, "styleLeft", {
            get: function () {
                return this.px(this.left);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MiniNodeComponent.prototype, "styleTop", {
            get: function () {
                return this.px(this.top);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MiniNodeComponent.prototype, "styleWidth", {
            get: function () {
                return this.px(this.width);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MiniNodeComponent.prototype, "styleHeight", {
            get: function () {
                return this.px(this.height);
            },
            enumerable: false,
            configurable: true
        });
        MiniNodeComponent.prototype.px = function (value) {
            return value + "px";
        };
        return MiniNodeComponent;
    }());
    MiniNodeComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'minimap-mini-node',
                    template: "",
                    host: {
                        'data-testid': 'minimap-node'
                    },
                    styles: [":host{display:block;position:absolute;background:rgba(110,136,255,.8);border:1px solid rgba(192,206,212,.6)}\n"]
                },] }
    ];
    MiniNodeComponent.propDecorators = {
        left: [{ type: core.Input }],
        top: [{ type: core.Input }],
        width: [{ type: core.Input }],
        height: [{ type: core.Input }],
        styleLeft: [{ type: core.HostBinding, args: ['style.left',] }],
        styleTop: [{ type: core.HostBinding, args: ['style.top',] }],
        styleWidth: [{ type: core.HostBinding, args: ['style.width',] }],
        styleHeight: [{ type: core.HostBinding, args: ['style.height',] }]
    };

    var ReteMinimapModule = /** @class */ (function () {
        function ReteMinimapModule() {
        }
        return ReteMinimapModule;
    }());
    ReteMinimapModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        MinimapComponent,
                        MiniViewportComponent,
                        MiniNodeComponent
                    ],
                    imports: [
                        common.CommonModule
                    ],
                    exports: [
                        MinimapComponent,
                        MiniViewportComponent,
                        MiniNodeComponent
                    ],
                    entryComponents: [
                        MinimapComponent
                    ]
                },] }
    ];

    var pinSize = 20;
    var PinComponent = /** @class */ (function () {
        function PinComponent(cdr) {
            var _this = this;
            this.cdr = cdr;
            this.menu = new core.EventEmitter();
            this.translate = new core.EventEmitter();
            this.down = new core.EventEmitter();
            this.drag = useDrag(function (dx, dy) {
                _this.translate.emit({ dx: dx, dy: dy });
            }, function () { return _this.getPointer(); });
            // this.cdr.detach()
        }
        Object.defineProperty(PinComponent.prototype, "_selected", {
            get: function () {
                return this.selected;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PinComponent.prototype, "top", {
            get: function () {
                return this.position.y - pinSize / 2 + "px";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PinComponent.prototype, "left", {
            get: function () {
                return this.position.x - pinSize / 2 + "px";
            },
            enumerable: false,
            configurable: true
        });
        PinComponent.prototype.pointerdown = function (event) {
            event.stopPropagation();
            event.preventDefault();
            this.drag.start(event);
            this.down.emit();
        };
        PinComponent.prototype.contextmenu = function (event) {
            event.stopPropagation();
            event.preventDefault();
            this.menu.emit();
        };
        PinComponent.prototype.ngOnChanges = function () {
            // this.cdr.detectChanges()
            // requestAnimationFrame(() => this.rendered())
        };
        return PinComponent;
    }());
    PinComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'reroute-pin',
                    template: '',
                    host: {
                        'data-testid': 'pin'
                    },
                    styles: [":host{display:block;width:20px;height:20px;box-sizing:border-box;background:steelblue;border:2px solid white;border-radius:20px;position:absolute}:host.selected{background:#ffd92c}\n"]
                },] }
    ];
    PinComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    PinComponent.propDecorators = {
        position: [{ type: core.Input }],
        selected: [{ type: core.Input }],
        getPointer: [{ type: core.Input }],
        menu: [{ type: core.Output }],
        translate: [{ type: core.Output }],
        down: [{ type: core.Output }],
        _selected: [{ type: core.HostBinding, args: ['class.selected',] }],
        top: [{ type: core.HostBinding, args: ['style.top',] }],
        left: [{ type: core.HostBinding, args: ['style.left',] }],
        pointerdown: [{ type: core.HostListener, args: ['pointerdown', ['$event'],] }],
        contextmenu: [{ type: core.HostListener, args: ['contextmenu', ['$event'],] }]
    };

    var ReteRerouteModule = /** @class */ (function () {
        function ReteRerouteModule() {
        }
        return ReteRerouteModule;
    }());
    ReteRerouteModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        PinsComponent,
                        PinComponent,
                    ],
                    imports: [
                        common.CommonModule
                    ],
                    exports: [
                        PinsComponent,
                        PinComponent,
                    ],
                    entryComponents: [
                        PinsComponent
                    ]
                },] }
    ];

    function reflect(obj) {
        if (typeof obj !== 'object' || obj === null) {
            return obj;
        }
        return new Proxy(obj, {
            get: function (target, prop) {
                return target[prop];
            },
            set: function (target, prop, value) {
                target[prop] = value;
                return true;
            },
            has: function (target, prop) { return prop in target; },
            deleteProperty: function (target, prop) { return delete target[prop]; },
            ownKeys: function (target) { return Reflect.ownKeys(target); }
        });
    }

    function getRenderer() {
        var elements$1 = new WeakMap();
        return {
            get: function (element) {
                return elements$1.get(element);
            },
            mount: function (element, key, component, injector, props) {
                // LIMITATION: If an element is remounted with the same identifier, the component cannot be replaced
                var CustomElement = customElements.get(key);
                if (!CustomElement) {
                    CustomElement = elements.createCustomElement(component, { injector: injector });
                    customElements.define(key, CustomElement);
                }
                var ngElement = new CustomElement(injector);
                Object.keys(props).forEach(function (key) {
                    ngElement[key] = props[key];
                });
                element.appendChild(ngElement);
                elements$1.set(element, { key: key, ngElement: ngElement });
            },
            update: function (_a, props) {
                var ngElement = _a.ngElement;
                Object.keys(props).forEach(function (key) {
                    ngElement.ngElementStrategy.setInputValue(key, reflect(props[key]));
                });
            },
            unmount: function (element) {
                var existing = elements$1.get(element);
                if (existing) {
                    existing.ngElement.remove();
                    elements$1.delete(element);
                }
            }
        };
    }
    /**
     * Angular plugin. Renders nodes, connections and other elements using React.
     * @priority 9
     * @emits connectionpath
     * @listens render
     * @listens unmount
     */
    var AngularPlugin = /** @class */ (function (_super) {
        __extends(AngularPlugin, _super);
        /**
         * @constructor
         * @param params Plugin properties
         * @param params.injector Angular's Injector instance
         */
        function AngularPlugin(params) {
            var _this = _super.call(this, 'angular-render') || this;
            _this.params = params;
            _this.presets = [];
            _this.owners = new WeakMap();
            _this.renderer = getRenderer();
            _this.addPipe(function (context) {
                if (!context || typeof context !== 'object' || !('type' in context))
                    return context;
                if (context.type === 'unmount') {
                    _this.unmount(context.data.element);
                }
                else if (context.type === 'render') {
                    if ('filled' in context.data && context.data.filled) {
                        return context;
                    }
                    if (_this.mount(context.data.element, context)) {
                        return Object.assign(Object.assign({}, context), { data: Object.assign(Object.assign({}, context.data), { filled: true }) });
                    }
                }
                return context;
            });
            return _this;
        }
        AngularPlugin.prototype.setParent = function (scope) {
            var _this = this;
            _super.prototype.setParent.call(this, scope);
            this.presets.forEach(function (preset) {
                if (preset.attach)
                    preset.attach(_this);
            });
        };
        AngularPlugin.prototype.unmount = function (element) {
            this.owners.delete(element);
            this.renderer.unmount(element);
        };
        AngularPlugin.prototype.mount = function (element, context) {
            var e_1, _a;
            var _this = this;
            var existing = this.renderer.get(element);
            if (existing) {
                this.presets.forEach(function (preset) {
                    if (_this.owners.get(element) !== preset)
                        return;
                    var result = preset.update(context, _this);
                    if (result) {
                        _this.renderer.update(existing, result);
                    }
                });
                return true;
            }
            try {
                for (var _b = __values(this.presets), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var preset = _c.value;
                    var result = preset.mount(context, this);
                    if (!result)
                        continue;
                    var key = result.key, component = result.component, props = result.props;
                    this.renderer.mount(element, key, component, this.params.injector, props);
                    this.owners.set(element, preset);
                    return true;
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return;
        };
        /**
         * Adds a preset to the plugin.
         * @param preset Preset that can render nodes, connections and other elements.
         */
        AngularPlugin.prototype.addPreset = function (preset) {
            var local = preset;
            if (local.attach)
                local.attach(this);
            this.presets.push(local);
        };
        return AngularPlugin;
    }(rete.Scope));

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AngularPlugin = AngularPlugin;
    exports.ConnectionComponent = ConnectionComponent;
    exports.ConnectionWrapperComponent = ConnectionWrapperComponent;
    exports.ContextMenuComponent = ContextMenuComponent;
    exports.ContextMenuItemComponent = ContextMenuItemComponent;
    exports.ContextMenuSearchComponent = ContextMenuSearchComponent;
    exports.ControlComponent = ControlComponent;
    exports.MiniNodeComponent = MiniNodeComponent;
    exports.MiniViewportComponent = MiniViewportComponent;
    exports.MinimapComponent = MinimapComponent;
    exports.NodeComponent = NodeComponent;
    exports.PinComponent = PinComponent;
    exports.PinsComponent = PinsComponent;
    exports.Presets = index;
    exports.RefDirective = RefDirective;
    exports.ReteContextMenuModule = ReteContextMenuModule;
    exports.ReteMinimapModule = ReteMinimapModule;
    exports.ReteModule = ReteModule;
    exports.ReteRerouteModule = ReteRerouteModule;
    exports.SocketComponent = SocketComponent;
    exports["ɵa"] = NodeComponent;
    exports["ɵb"] = ConnectionComponent;
    exports["ɵc"] = ConnectionWrapperComponent;
    exports["ɵd"] = SocketComponent;
    exports["ɵe"] = ControlComponent;
    exports["ɵf"] = ContextMenuComponent;
    exports["ɵg"] = ContextMenuSearchComponent;
    exports["ɵh"] = ContextMenuItemComponent;
    exports["ɵi"] = MinimapComponent;
    exports["ɵj"] = MiniViewportComponent;
    exports["ɵk"] = MiniNodeComponent;
    exports["ɵl"] = PinsComponent;
    exports["ɵm"] = PinComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=rete-angular-plugin.umd.js.map
