import { ChangeDetectorRef, OnChanges, OnDestroy } from '@angular/core';
import { Item } from '../../types';
export declare class ContextMenuComponent implements OnChanges, OnDestroy {
    private cdr;
    items: Item[];
    delay: number;
    searchBar?: boolean;
    onHide: () => void;
    rendered: () => void;
    filter: string;
    hide: {
        timeout: number;
        cancel(): void;
        call(delay: number): void;
    };
    customAttribute: string;
    pointerover(): void;
    pointerleave(): void;
    constructor(cdr: ChangeDetectorRef);
    ngOnChanges(): void;
    setFilter(value: string): void;
    getItems(): Item[];
    ngOnDestroy(): void;
}
