import { MinimapData } from '../../types';
export declare class MiniViewportComponent {
    left: number;
    top: number;
    width: number;
    height: number;
    containerWidth: number;
    translate: MinimapData['translate'];
    drag: {
        start(e: {
            pageX: number;
            pageY: number;
        }): void;
    };
    get styleLeft(): string;
    get styleTop(): string;
    get styleWidth(): string;
    get styleHeight(): string;
    pointerdown(event: PointerEvent): void;
    px(value: number): string;
    scale(v: number): number;
    invert(v: number): number;
    onDrag(dx: number, dy: number): void;
}
