import { ChangeDetectorRef, OnChanges, EventEmitter } from '@angular/core';
import { Position } from '../../types';
export declare class PinComponent implements OnChanges {
    private cdr;
    position: Position;
    selected?: boolean;
    getPointer: () => Position;
    menu: EventEmitter<void>;
    translate: EventEmitter<{
        dx: number;
        dy: number;
    }>;
    down: EventEmitter<void>;
    drag: {
        start(e: {
            pageX: number;
            pageY: number;
        }): void;
    };
    get _selected(): boolean;
    get top(): string;
    get left(): string;
    pointerdown(event: PointerEvent): void;
    contextmenu(event: MouseEvent): void;
    constructor(cdr: ChangeDetectorRef);
    ngOnChanges(): void;
}
