import { ChangeDetectorRef, OnChanges } from '@angular/core';
import { Pin, PinData, Position } from '../../types';
export declare class PinsComponent implements OnChanges {
    private cdr;
    rendered: () => void;
    pins: PinData['pins'];
    down?: (id: string) => void;
    translate?: (id: string, dx: number, dy: number) => void;
    menu?: (id: string) => void;
    getPointer?: () => Position;
    constructor(cdr: ChangeDetectorRef);
    ngOnChanges(): void;
    track(_: number, item: Pin): string;
}
