(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rete'), require('rete-render-utils'), require('@angular/core'), require('@angular/common'), require('rete-area-plugin'), require('@angular/elements')) :
    typeof define === 'function' && define.amd ? define('rete-angular-plugin-ng12', ['exports', 'rete', 'rete-render-utils', '@angular/core', '@angular/common', 'rete-area-plugin', '@angular/elements'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["rete-angular-plugin-ng12"] = {}, global.rete, global.reteRenderUtils, global.ng.core, global.ng.common, global.reteAreaPlugin, global.ng.elements));
})(this, (function (exports, rete, reteRenderUtils, i0, i1, reteAreaPlugin, elements) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __esDecorate(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
        function accept(f) { if (f !== void 0 && typeof f !== "function")
            throw new TypeError("Function expected"); return f; }
        var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
        var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
        var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
        var _, done = false;
        for (var i = decorators.length - 1; i >= 0; i--) {
            var context = {};
            for (var p in contextIn)
                context[p] = p === "access" ? {} : contextIn[p];
            for (var p in contextIn.access)
                context.access[p] = contextIn.access[p];
            context.addInitializer = function (f) { if (done)
                throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
            var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
            if (kind === "accessor") {
                if (result === void 0)
                    continue;
                if (result === null || typeof result !== "object")
                    throw new TypeError("Object expected");
                if (_ = accept(result.get))
                    descriptor.get = _;
                if (_ = accept(result.set))
                    descriptor.set = _;
                if (_ = accept(result.init))
                    initializers.push(_);
            }
            else if (_ = accept(result)) {
                if (kind === "field")
                    initializers.push(_);
                else
                    descriptor[key] = _;
            }
        }
        if (target)
            Object.defineProperty(target, contextIn.name, descriptor);
        done = true;
    }
    ;
    function __runInitializers(thisArg, initializers, value) {
        var useValue = arguments.length > 2;
        for (var i = 0; i < initializers.length; i++) {
            value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
        }
        return useValue ? value : void 0;
    }
    ;
    function __propKey(x) {
        return typeof x === "symbol" ? x : "".concat(x);
    }
    ;
    function __setFunctionName(f, name, prefix) {
        if (typeof name === "symbol")
            name = name.description ? "[".concat(name.description, "]") : "";
        return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
    }
    ;
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (g && (g = 0, op[0] && (_ = 0)), _)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        var desc = Object.getOwnPropertyDescriptor(m, k);
        if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
            desc = { enumerable: true, get: function () { return m[k]; } };
        }
        Object.defineProperty(o, k2, desc);
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }
    function __classPrivateFieldIn(state, receiver) {
        if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function"))
            throw new TypeError("Cannot use 'in' operator on non-object");
        return typeof state === "function" ? receiver === state : state.has(receiver);
    }

    var RefDirective = /** @class */ (function () {
        function RefDirective(el) {
            this.el = el;
        }
        RefDirective.prototype.ngOnChanges = function () {
            this.emit({ type: 'render', data: Object.assign(Object.assign({}, this.data), { element: this.el.nativeElement }) });
        };
        RefDirective.prototype.ngOnDestroy = function () {
            this.emit({ type: 'unmount', data: { element: this.el.nativeElement } });
        };
        return RefDirective;
    }());
    RefDirective.ɵfac = function RefDirective_Factory(t) { return new (t || RefDirective)(i0__namespace.ɵɵdirectiveInject(i0__namespace.ElementRef)); };
    RefDirective.ɵdir = /*@__PURE__*/ i0__namespace.ɵɵdefineDirective({ type: RefDirective, selectors: [["", "refComponent", ""]], inputs: { data: "data", emit: "emit" }, features: [i0__namespace.ɵɵNgOnChangesFeature] });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(RefDirective, [{
                type: i0.Directive,
                args: [{
                        selector: '[refComponent]'
                    }]
            }], function () { return [{ type: i0__namespace.ElementRef }]; }, { data: [{
                    type: i0.Input
                }], emit: [{
                    type: i0.Input
                }] });
    })();

    var _c0$1 = function (a2, a3, a4, a5) { return { type: "socket", side: "output", key: a2, nodeId: a3, payload: a4, seed: a5 }; };
    function NodeComponent_div_2_Template(rf, ctx) {
        if (rf & 1) {
            i0__namespace.ɵɵelementStart(0, "div", 4);
            i0__namespace.ɵɵelementStart(1, "div", 5);
            i0__namespace.ɵɵtext(2);
            i0__namespace.ɵɵelementEnd();
            i0__namespace.ɵɵelement(3, "div", 6);
            i0__namespace.ɵɵelementEnd();
        }
        if (rf & 2) {
            var output_r3 = ctx.$implicit;
            var ctx_r0 = i0__namespace.ɵɵnextContext();
            i0__namespace.ɵɵattribute("data-testid", "output-" + output_r3.key);
            i0__namespace.ɵɵadvance(2);
            i0__namespace.ɵɵtextInterpolate(output_r3.value == null ? null : output_r3.value.label);
            i0__namespace.ɵɵadvance(1);
            i0__namespace.ɵɵproperty("data", i0__namespace.ɵɵpureFunction4(4, _c0$1, output_r3.key, ctx_r0.data.id, output_r3.value == null ? null : output_r3.value.socket, ctx_r0.seed))("emit", ctx_r0.emit);
        }
    }
    var _c1 = function (a1) { return { type: "control", payload: a1 }; };
    function NodeComponent_div_4_Template(rf, ctx) {
        if (rf & 1) {
            i0__namespace.ɵɵelement(0, "div", 7);
        }
        if (rf & 2) {
            var control_r4 = ctx.$implicit;
            var ctx_r1 = i0__namespace.ɵɵnextContext();
            i0__namespace.ɵɵproperty("data", i0__namespace.ɵɵpureFunction1(3, _c1, control_r4.value))("emit", ctx_r1.emit);
            i0__namespace.ɵɵattribute("data-testid", "control-" + control_r4.key);
        }
    }
    function NodeComponent_div_6_div_2_Template(rf, ctx) {
        if (rf & 1) {
            i0__namespace.ɵɵelementStart(0, "div", 12);
            i0__namespace.ɵɵtext(1);
            i0__namespace.ɵɵelementEnd();
        }
        if (rf & 2) {
            var input_r5 = i0__namespace.ɵɵnextContext().$implicit;
            i0__namespace.ɵɵadvance(1);
            i0__namespace.ɵɵtextInterpolate(input_r5.value == null ? null : input_r5.value.label);
        }
    }
    var _c2 = function (a2, a3, a4, a5) { return { type: "socket", side: "input", key: a2, nodeId: a3, payload: a4, seed: a5 }; };
    function NodeComponent_div_6_Template(rf, ctx) {
        if (rf & 1) {
            i0__namespace.ɵɵelementStart(0, "div", 8);
            i0__namespace.ɵɵelement(1, "div", 9);
            i0__namespace.ɵɵtemplate(2, NodeComponent_div_6_div_2_Template, 2, 1, "div", 10);
            i0__namespace.ɵɵelement(3, "div", 11);
            i0__namespace.ɵɵelementEnd();
        }
        if (rf & 2) {
            var input_r5 = ctx.$implicit;
            var ctx_r2 = i0__namespace.ɵɵnextContext();
            i0__namespace.ɵɵattribute("data-testid", "input-" + input_r5.key);
            i0__namespace.ɵɵadvance(1);
            i0__namespace.ɵɵproperty("data", i0__namespace.ɵɵpureFunction4(8, _c2, input_r5.key, ctx_r2.data.id, input_r5.value == null ? null : input_r5.value.socket, ctx_r2.seed))("emit", ctx_r2.emit);
            i0__namespace.ɵɵadvance(1);
            i0__namespace.ɵɵproperty("ngIf", !(input_r5.value == null ? null : input_r5.value.control) || !(input_r5.value == null ? null : input_r5.value.showControl));
            i0__namespace.ɵɵadvance(1);
            i0__namespace.ɵɵstyleProp("display", (input_r5.value == null ? null : input_r5.value.control) && (input_r5.value == null ? null : input_r5.value.showControl) ? "" : "none");
            i0__namespace.ɵɵproperty("data", i0__namespace.ɵɵpureFunction1(13, _c1, input_r5.value == null ? null : input_r5.value.control))("emit", ctx_r2.emit);
        }
    }
    var NodeComponent = /** @class */ (function () {
        function NodeComponent(cdr) {
            this.cdr = cdr;
            this.seed = 0;
            this.cdr.detach();
        }
        Object.defineProperty(NodeComponent.prototype, "width", {
            get: function () {
                return this.data.width;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NodeComponent.prototype, "height", {
            get: function () {
                return this.data.height;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NodeComponent.prototype, "selected", {
            get: function () {
                return this.data.selected;
            },
            enumerable: false,
            configurable: true
        });
        NodeComponent.prototype.ngOnChanges = function () {
            var _this = this;
            this.cdr.detectChanges();
            requestAnimationFrame(function () { return _this.rendered(); });
            this.seed++; // force render sockets
        };
        NodeComponent.prototype.sortByIndex = function (a, b) {
            var _a, _b;
            var ai = ((_a = a.value) === null || _a === void 0 ? void 0 : _a.index) || 0;
            var bi = ((_b = b.value) === null || _b === void 0 ? void 0 : _b.index) || 0;
            return ai - bi;
        };
        return NodeComponent;
    }());
    NodeComponent.ɵfac = function NodeComponent_Factory(t) { return new (t || NodeComponent)(i0__namespace.ɵɵdirectiveInject(i0__namespace.ChangeDetectorRef)); };
    NodeComponent.ɵcmp = /*@__PURE__*/ i0__namespace.ɵɵdefineComponent({ type: NodeComponent, selectors: [["ng-component"]], hostAttrs: ["data-testid", "node"], hostVars: 6, hostBindings: function NodeComponent_HostBindings(rf, ctx) {
            if (rf & 2) {
                i0__namespace.ɵɵstyleProp("width", ctx.width, "px")("height", ctx.height, "px");
                i0__namespace.ɵɵclassProp("selected", ctx.selected);
            }
        }, inputs: { data: "data", emit: "emit", rendered: "rendered" }, features: [i0__namespace.ɵɵNgOnChangesFeature], decls: 8, vars: 13, consts: [["data-testid", "title", 1, "title"], ["class", "output", 4, "ngFor", "ngForOf"], ["class", "control", "refComponent", "", 3, "data", "emit", 4, "ngFor", "ngForOf"], ["class", "input", 4, "ngFor", "ngForOf"], [1, "output"], ["data-testid", "output-title", 1, "output-title"], ["refComponent", "", "data-testid", "output-socket", 1, "output-socket", 3, "data", "emit"], ["refComponent", "", 1, "control", 3, "data", "emit"], [1, "input"], ["refComponent", "", "data-testid", "input-socket", 1, "input-socket", 3, "data", "emit"], ["class", "input-title", "data-testid", "input-title", 4, "ngIf"], ["refComponent", "", "data-testid", "input-control", 1, "input-control", 3, "data", "emit"], ["data-testid", "input-title", 1, "input-title"]], template: function NodeComponent_Template(rf, ctx) {
            if (rf & 1) {
                i0__namespace.ɵɵelementStart(0, "div", 0);
                i0__namespace.ɵɵtext(1);
                i0__namespace.ɵɵelementEnd();
                i0__namespace.ɵɵtemplate(2, NodeComponent_div_2_Template, 4, 9, "div", 1);
                i0__namespace.ɵɵpipe(3, "keyvalue");
                i0__namespace.ɵɵtemplate(4, NodeComponent_div_4_Template, 1, 5, "div", 2);
                i0__namespace.ɵɵpipe(5, "keyvalue");
                i0__namespace.ɵɵtemplate(6, NodeComponent_div_6_Template, 4, 15, "div", 3);
                i0__namespace.ɵɵpipe(7, "keyvalue");
            }
            if (rf & 2) {
                i0__namespace.ɵɵadvance(1);
                i0__namespace.ɵɵtextInterpolate(ctx.data.label);
                i0__namespace.ɵɵadvance(1);
                i0__namespace.ɵɵproperty("ngForOf", i0__namespace.ɵɵpipeBind2(3, 4, ctx.data.outputs, ctx.sortByIndex));
                i0__namespace.ɵɵadvance(2);
                i0__namespace.ɵɵproperty("ngForOf", i0__namespace.ɵɵpipeBind2(5, 7, ctx.data.controls, ctx.sortByIndex));
                i0__namespace.ɵɵadvance(2);
                i0__namespace.ɵɵproperty("ngForOf", i0__namespace.ɵɵpipeBind2(7, 10, ctx.data.inputs, ctx.sortByIndex));
            }
        }, directives: [i1__namespace.NgForOf, RefDirective, i1__namespace.NgIf], pipes: [i1__namespace.KeyValuePipe], styles: ["[_nghost-%COMP%]{display:block;background:rgba(110,136,255,.8);border:2px solid #4e58bf;border-radius:10px;cursor:pointer;box-sizing:border-box;width:180px;height:auto;padding-bottom:6px;position:relative;-webkit-user-select:none;user-select:none;line-height:initial;font-family:Arial}[_nghost-%COMP%]:hover{background:rgba(130,153,255,.8)}.selected[_nghost-%COMP%]{background:#ffd92c;border-color:#e3c000}[_nghost-%COMP%]   .title[_ngcontent-%COMP%]{color:#fff;font-family:sans-serif;font-size:18px;padding:8px}[_nghost-%COMP%]   .output[_ngcontent-%COMP%]{text-align:right}[_nghost-%COMP%]   .input[_ngcontent-%COMP%]{text-align:left}[_nghost-%COMP%]   .input-title[_ngcontent-%COMP%], [_nghost-%COMP%]   .output-title[_ngcontent-%COMP%]{vertical-align:middle;color:#fff;display:inline-block;font-family:sans-serif;font-size:14px;margin:6px;line-height:24px}[_nghost-%COMP%]   .input-title[hidden][_ngcontent-%COMP%], [_nghost-%COMP%]   .output-title[hidden][_ngcontent-%COMP%]{display:none}[_nghost-%COMP%]   .output-socket[_ngcontent-%COMP%]{text-align:right;margin-right:-18px;display:inline-block}[_nghost-%COMP%]   .input-socket[_ngcontent-%COMP%]{text-align:left;margin-left:-18px;display:inline-block}[_nghost-%COMP%]   .input-control[_ngcontent-%COMP%]{z-index:1;width:calc(100% - 36px);vertical-align:middle;display:inline-block}[_nghost-%COMP%]   .control[_ngcontent-%COMP%]{padding:6px 18px}"] });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(NodeComponent, [{
                type: i0.Component,
                args: [{
                        // [component-directive]
                        templateUrl: './node.component.html',
                        styleUrls: ['./node.component.sass'],
                        host: {
                            'data-testid': 'node'
                        }
                    }]
            }], function () { return [{ type: i0__namespace.ChangeDetectorRef }]; }, { data: [{
                    type: i0.Input
                }], emit: [{
                    type: i0.Input
                }], rendered: [{
                    type: i0.Input
                }], width: [{
                    type: i0.HostBinding,
                    args: ['style.width.px']
                }], height: [{
                    type: i0.HostBinding,
                    args: ['style.height.px']
                }], selected: [{
                    type: i0.HostBinding,
                    args: ['class.selected']
                }] });
    })();

    var SocketComponent = /** @class */ (function () {
        function SocketComponent(cdr) {
            this.cdr = cdr;
            this.cdr.detach();
        }
        Object.defineProperty(SocketComponent.prototype, "title", {
            get: function () {
                return this.data.name;
            },
            enumerable: false,
            configurable: true
        });
        SocketComponent.prototype.ngOnChanges = function () {
            var _this = this;
            this.cdr.detectChanges();
            requestAnimationFrame(function () { return _this.rendered(); });
        };
        return SocketComponent;
    }());
    SocketComponent.ɵfac = function SocketComponent_Factory(t) { return new (t || SocketComponent)(i0__namespace.ɵɵdirectiveInject(i0__namespace.ChangeDetectorRef)); };
    SocketComponent.ɵcmp = /*@__PURE__*/ i0__namespace.ɵɵdefineComponent({ type: SocketComponent, selectors: [["ng-component"]], hostVars: 1, hostBindings: function SocketComponent_HostBindings(rf, ctx) {
            if (rf & 2) {
                i0__namespace.ɵɵhostProperty("title", ctx.title);
            }
        }, inputs: { data: "data", rendered: "rendered" }, features: [i0__namespace.ɵɵNgOnChangesFeature], decls: 0, vars: 0, template: function SocketComponent_Template(rf, ctx) { }, styles: ["[_nghost-%COMP%]{display:inline-block;cursor:pointer;border:1px solid white;border-radius:12px;width:24px;height:24px;margin:6px;vertical-align:middle;background:#96b38a;z-index:2;box-sizing:border-box}[_nghost-%COMP%]:hover{border-width:4px}.multiple[_nghost-%COMP%]{border-color:#ff0}.output[_nghost-%COMP%]{margin-right:-12px}.input[_nghost-%COMP%]{margin-left:-12px}"] });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(SocketComponent, [{
                type: i0.Component,
                args: [{
                        template: "",
                        styleUrls: ['./socket.component.sass']
                    }]
            }], function () { return [{ type: i0__namespace.ChangeDetectorRef }]; }, { data: [{
                    type: i0.Input
                }], rendered: [{
                    type: i0.Input
                }], title: [{
                    type: i0.HostBinding,
                    args: ['title']
                }] });
    })();

    var ControlComponent = /** @class */ (function () {
        function ControlComponent(cdr) {
            this.cdr = cdr;
            this.cdr.detach();
        }
        ControlComponent.prototype.pointerdown = function (event) {
            event.stopPropagation();
        };
        ControlComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            var seed = changes['seed'];
            var data = changes['data'];
            if ((seed && seed.currentValue !== seed.previousValue)
                || (data && data.currentValue !== data.previousValue)) {
                this.cdr.detectChanges();
            }
            requestAnimationFrame(function () { return _this.rendered(); });
        };
        ControlComponent.prototype.onChange = function (e) {
            var target = e.target;
            var value = (this.data.type === 'number'
                ? +target.value
                : target.value);
            this.data.setValue(value);
            this.cdr.detectChanges();
        };
        return ControlComponent;
    }());
    ControlComponent.ɵfac = function ControlComponent_Factory(t) { return new (t || ControlComponent)(i0__namespace.ɵɵdirectiveInject(i0__namespace.ChangeDetectorRef)); };
    ControlComponent.ɵcmp = /*@__PURE__*/ i0__namespace.ɵɵdefineComponent({ type: ControlComponent, selectors: [["ng-component"]], hostBindings: function ControlComponent_HostBindings(rf, ctx) {
            if (rf & 1) {
                i0__namespace.ɵɵlistener("pointerdown", function ControlComponent_pointerdown_HostBindingHandler($event) { return ctx.pointerdown($event); });
            }
        }, inputs: { data: "data", rendered: "rendered" }, features: [i0__namespace.ɵɵNgOnChangesFeature], decls: 1, vars: 3, consts: [[3, "value", "readonly", "type", "input"]], template: function ControlComponent_Template(rf, ctx) {
            if (rf & 1) {
                i0__namespace.ɵɵelementStart(0, "input", 0);
                i0__namespace.ɵɵlistener("input", function ControlComponent_Template_input_input_0_listener($event) { return ctx.onChange($event); });
                i0__namespace.ɵɵelementEnd();
            }
            if (rf & 2) {
                i0__namespace.ɵɵproperty("value", ctx.data.value)("readonly", ctx.data.readonly)("type", ctx.data.type);
            }
        }, styles: ["input[_ngcontent-%COMP%]{width:100%;border-radius:30px;background-color:#fff;padding:2px 6px;border:1px solid #999;font-size:110%;box-sizing:border-box}"] });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(ControlComponent, [{
                type: i0.Component,
                args: [{
                        templateUrl: "./control.component.html",
                        styleUrls: ['./control.component.sass']
                    }]
            }], function () { return [{ type: i0__namespace.ChangeDetectorRef }]; }, { data: [{
                    type: i0.Input
                }], rendered: [{
                    type: i0.Input
                }], pointerdown: [{
                    type: i0.HostListener,
                    args: ['pointerdown', ['$event']]
                }] });
    })();

    var ConnectionComponent = /** @class */ (function () {
        function ConnectionComponent() {
        }
        return ConnectionComponent;
    }());
    ConnectionComponent.ɵfac = function ConnectionComponent_Factory(t) { return new (t || ConnectionComponent)(); };
    ConnectionComponent.ɵcmp = /*@__PURE__*/ i0__namespace.ɵɵdefineComponent({ type: ConnectionComponent, selectors: [["connection"]], inputs: { data: "data", start: "start", end: "end", path: "path" }, decls: 2, vars: 1, consts: [["data-testid", "connection"]], template: function ConnectionComponent_Template(rf, ctx) {
            if (rf & 1) {
                i0__namespace.ɵɵnamespaceSVG();
                i0__namespace.ɵɵelementStart(0, "svg", 0);
                i0__namespace.ɵɵelement(1, "path");
                i0__namespace.ɵɵelementEnd();
            }
            if (rf & 2) {
                i0__namespace.ɵɵadvance(1);
                i0__namespace.ɵɵattribute("d", ctx.path);
            }
        }, styles: ["svg[_ngcontent-%COMP%]{overflow:visible!important;position:absolute;pointer-events:none;width:9999px;height:9999px}svg[_ngcontent-%COMP%]   path[_ngcontent-%COMP%]{fill:none;stroke-width:5px;stroke:#4682b4;pointer-events:auto}"] });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(ConnectionComponent, [{
                type: i0.Component,
                args: [{
                        selector: 'connection',
                        templateUrl: './connection.component.html',
                        styleUrls: ['./connection.component.sass']
                    }]
            }], null, { data: [{
                    type: i0.Input
                }], start: [{
                    type: i0.Input
                }], end: [{
                    type: i0.Input
                }], path: [{
                    type: i0.Input
                }] });
    })();

    var ConnectionWrapperComponent = /** @class */ (function () {
        function ConnectionWrapperComponent(cdr, viewContainerRef, componentFactoryResolver) {
            this.cdr = cdr;
            this.viewContainerRef = viewContainerRef;
            this.componentFactoryResolver = componentFactoryResolver;
            this.startOb = null;
            this.endOb = null;
            this.cdr.detach();
        }
        Object.defineProperty(ConnectionWrapperComponent.prototype, "_start", {
            get: function () {
                return 'x' in this.start ? this.start : this.startOb;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ConnectionWrapperComponent.prototype, "_end", {
            get: function () {
                return 'x' in this.end ? this.end : this.endOb;
            },
            enumerable: false,
            configurable: true
        });
        ConnectionWrapperComponent.prototype.ngOnChanges = function () {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.updatePath()];
                        case 1:
                            _a.sent();
                            requestAnimationFrame(function () { return _this.rendered(); });
                            this.cdr.detectChanges();
                            this.update();
                            return [2 /*return*/];
                    }
                });
            });
        };
        ConnectionWrapperComponent.prototype.updatePath = function () {
            return __awaiter(this, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            if (!(this._start && this._end)) return [3 /*break*/, 2];
                            _a = this;
                            return [4 /*yield*/, this.path(this._start, this._end)];
                        case 1:
                            _a._path = _b.sent();
                            _b.label = 2;
                        case 2: return [2 /*return*/];
                    }
                });
            });
        };
        ConnectionWrapperComponent.prototype.ngOnInit = function () {
            var _this = this;
            if (typeof this.start === 'function') {
                this.start(function (value) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                this.startOb = value;
                                return [4 /*yield*/, this.updatePath()];
                            case 1:
                                _a.sent();
                                this.cdr.detectChanges();
                                this.update();
                                return [2 /*return*/];
                        }
                    });
                }); });
            }
            if (typeof this.end === 'function') {
                this.end(function (value) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                this.endOb = value;
                                return [4 /*yield*/, this.updatePath()];
                            case 1:
                                _a.sent();
                                this.cdr.detectChanges();
                                this.update();
                                return [2 /*return*/];
                        }
                    });
                }); });
            }
            var componentFactory = this.componentFactoryResolver.resolveComponentFactory(this.connectionComponent);
            this.viewContainerRef.clear();
            this.ref = this.viewContainerRef.createComponent(componentFactory);
            this.update();
        };
        ConnectionWrapperComponent.prototype.update = function () {
            this.ref.instance.data = this.data;
            this.ref.instance.start = this._start;
            this.ref.instance.end = this._end;
            this.ref.instance.path = this._path;
        };
        return ConnectionWrapperComponent;
    }());
    ConnectionWrapperComponent.ɵfac = function ConnectionWrapperComponent_Factory(t) { return new (t || ConnectionWrapperComponent)(i0__namespace.ɵɵdirectiveInject(i0__namespace.ChangeDetectorRef), i0__namespace.ɵɵdirectiveInject(i0__namespace.ViewContainerRef), i0__namespace.ɵɵdirectiveInject(i0__namespace.ComponentFactoryResolver)); };
    ConnectionWrapperComponent.ɵcmp = /*@__PURE__*/ i0__namespace.ɵɵdefineComponent({ type: ConnectionWrapperComponent, selectors: [["ng-component"]], inputs: { data: "data", start: "start", end: "end", path: "path", rendered: "rendered", connectionComponent: "connectionComponent" }, features: [i0__namespace.ɵɵNgOnChangesFeature], decls: 0, vars: 0, template: function ConnectionWrapperComponent_Template(rf, ctx) { }, encapsulation: 2 });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(ConnectionWrapperComponent, [{
                type: i0.Component,
                args: [{
                        template: ''
                    }]
            }], function () { return [{ type: i0__namespace.ChangeDetectorRef }, { type: i0__namespace.ViewContainerRef }, { type: i0__namespace.ComponentFactoryResolver }]; }, { data: [{
                    type: i0.Input
                }], start: [{
                    type: i0.Input
                }], end: [{
                    type: i0.Input
                }], path: [{
                    type: i0.Input
                }], rendered: [{
                    type: i0.Input
                }], connectionComponent: [{
                    type: i0.Input
                }] });
    })();

    /**
     * Classic preset for rendering nodes, connections, controls and sockets.
     */
    function setup$3(props) {
        var positionWatcher = typeof (props === null || props === void 0 ? void 0 : props.socketPositionWatcher) === 'undefined'
            ? reteRenderUtils.getDOMSocketPosition() // fix Type instantiation is excessively deep and possibly infinite.
            : props === null || props === void 0 ? void 0 : props.socketPositionWatcher;
        var _a = (props === null || props === void 0 ? void 0 : props.customize) || {}, node = _a.node, connection = _a.connection, socket = _a.socket, control = _a.control;
        return {
            attach: function (plugin) {
                positionWatcher.attach(plugin);
            },
            update: function (context) {
                var data = context.data.payload;
                if (context.data.type === 'connection') {
                    var _a = context.data, start = _a.start, end = _a.end;
                    return Object.assign(Object.assign({ data: data }, (start ? { start: start } : {})), (end ? { end: end } : {}));
                }
                return { data: data };
            },
            mount: function (context, plugin) {
                var _this = this;
                var parent = plugin.parentScope();
                var emit = parent.emit.bind(parent);
                var rendered = function () {
                    emit({ type: 'rendered', data: context.data });
                };
                if (context.data.type === 'node') {
                    var component = node ? node(context.data) : NodeComponent;
                    return {
                        key: "node-" + context.data.payload.id,
                        component: component,
                        props: {
                            data: context.data.payload,
                            emit: emit,
                            rendered: rendered
                        }
                    };
                }
                if (context.data.type === 'connection') {
                    var component = connection ? connection(context.data) : ConnectionComponent;
                    var id = context.data.payload.id;
                    var _a = context.data.payload, sourceOutput_1 = _a.sourceOutput, targetInput_1 = _a.targetInput, source_1 = _a.source, target_1 = _a.target;
                    var _b = context.data, start = _b.start, end = _b.end, payload_1 = _b.payload;
                    return {
                        key: "connection-" + id,
                        component: ConnectionWrapperComponent,
                        props: {
                            connectionComponent: component,
                            data: payload_1,
                            start: start || (function (change) { return positionWatcher.listen(source_1, 'output', sourceOutput_1, change); }),
                            end: end || (function (change) { return positionWatcher.listen(target_1, 'input', targetInput_1, change); }),
                            path: function (start, end) { return __awaiter(_this, void 0, void 0, function () {
                                var response, _a, path, points, curvature;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0: return [4 /*yield*/, plugin.emit({ type: 'connectionpath', data: { payload: payload_1, points: [start, end] } })];
                                        case 1:
                                            response = _b.sent();
                                            if (!response)
                                                return [2 /*return*/, ''];
                                            _a = response.data, path = _a.path, points = _a.points;
                                            curvature = 0.3;
                                            if (!path && points.length !== 2)
                                                throw new Error('cannot render connection with a custom number of points');
                                            if (!path)
                                                return [2 /*return*/, payload_1.isLoop
                                                        ? reteRenderUtils.loopConnectionPath(points, curvature, 120)
                                                        : reteRenderUtils.classicConnectionPath(points, curvature)];
                                            return [2 /*return*/, path];
                                    }
                                });
                            }); },
                            rendered: rendered
                        }
                    };
                }
                if (context.data.type === 'socket') {
                    var component = socket ? socket(context.data) : SocketComponent;
                    return {
                        key: "socket-" + rete.getUID(),
                        component: component,
                        props: {
                            data: context.data.payload,
                            rendered: rendered
                        }
                    };
                }
                if (context.data.type === 'control') {
                    var component = control
                        ? control(context.data)
                        : (context.data.payload instanceof rete.ClassicPreset.InputControl
                            ? ControlComponent
                            : null);
                    if (component) {
                        return {
                            key: "control-" + context.data.payload.id,
                            component: component,
                            props: {
                                data: context.data.payload,
                                rendered: rendered
                            }
                        };
                    }
                    return;
                }
                return;
            }
        };
    }

    var index$4 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        setup: setup$3
    });

    function debounce(cb) {
        return {
            timeout: null,
            cancel: function () {
                if (this.timeout) {
                    window.clearTimeout(this.timeout);
                    this.timeout = null;
                }
            },
            call: function (delay) {
                this.timeout = window.setTimeout(function () {
                    cb();
                }, delay);
            }
        };
    }

    var ContextMenuSearchComponent = /** @class */ (function () {
        function ContextMenuSearchComponent() {
            this.update = new i0.EventEmitter();
        }
        return ContextMenuSearchComponent;
    }());
    ContextMenuSearchComponent.ɵfac = function ContextMenuSearchComponent_Factory(t) { return new (t || ContextMenuSearchComponent)(); };
    ContextMenuSearchComponent.ɵcmp = /*@__PURE__*/ i0__namespace.ɵɵdefineComponent({ type: ContextMenuSearchComponent, selectors: [["context-menu-search"]], inputs: { value: "value" }, outputs: { update: "update" }, decls: 1, vars: 1, consts: [["data-testid", "context-menu-search-input", 1, "search", 3, "value", "input"]], template: function ContextMenuSearchComponent_Template(rf, ctx) {
            if (rf & 1) {
                i0__namespace.ɵɵelementStart(0, "input", 0);
                i0__namespace.ɵɵlistener("input", function ContextMenuSearchComponent_Template_input_input_0_listener($event) { var tmp_b_0; return ctx.update.emit(((tmp_b_0 = $event.target) == null ? null : tmp_b_0.value) || ""); });
                i0__namespace.ɵɵelementEnd();
            }
            if (rf & 2) {
                i0__namespace.ɵɵproperty("value", ctx.value);
            }
        }, styles: [".search[_ngcontent-%COMP%]{color:#fff;padding:1px 8px;border:1px solid white;border-radius:10px;font-size:16px;font-family:serif;width:100%;box-sizing:border-box;background:transparent}"] });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(ContextMenuSearchComponent, [{
                type: i0.Component,
                args: [{
                        selector: 'context-menu-search',
                        templateUrl: './search.component.html',
                        styleUrls: ['./search.component.sass']
                    }]
            }], null, { value: [{
                    type: i0.Input
                }], update: [{
                    type: i0.Output
                }] });
    })();

    function ContextMenuItemComponent_div_1_context_menu_item_1_Template(rf, ctx) {
        if (rf & 1) {
            var _r4_1 = i0__namespace.ɵɵgetCurrentView();
            i0__namespace.ɵɵelementStart(0, "context-menu-item", 3);
            i0__namespace.ɵɵlistener("select", function ContextMenuItemComponent_div_1_context_menu_item_1_Template_context_menu_item_select_0_listener() { var restoredCtx = i0__namespace.ɵɵrestoreView(_r4_1); var item_r2 = restoredCtx.$implicit; return item_r2.handler(); })("hide", function ContextMenuItemComponent_div_1_context_menu_item_1_Template_context_menu_item_hide_0_listener() { i0__namespace.ɵɵrestoreView(_r4_1); var ctx_r5 = i0__namespace.ɵɵnextContext(2); return ctx_r5.hide.emit(); });
            i0__namespace.ɵɵtext(1);
            i0__namespace.ɵɵelementEnd();
        }
        if (rf & 2) {
            var item_r2 = ctx.$implicit;
            var ctx_r1 = i0__namespace.ɵɵnextContext(2);
            i0__namespace.ɵɵproperty("delay", ctx_r1.delay);
            i0__namespace.ɵɵadvance(1);
            i0__namespace.ɵɵtextInterpolate1(" ", item_r2.label, " ");
        }
    }
    function ContextMenuItemComponent_div_1_Template(rf, ctx) {
        if (rf & 1) {
            i0__namespace.ɵɵelementStart(0, "div", 1);
            i0__namespace.ɵɵtemplate(1, ContextMenuItemComponent_div_1_context_menu_item_1_Template, 2, 2, "context-menu-item", 2);
            i0__namespace.ɵɵelementEnd();
        }
        if (rf & 2) {
            var ctx_r0 = i0__namespace.ɵɵnextContext();
            i0__namespace.ɵɵadvance(1);
            i0__namespace.ɵɵproperty("ngForOf", ctx_r0.subitems);
        }
    }
    var _c0 = ["*"];
    // [imports]
    var ContextMenuItemComponent = /** @class */ (function () {
        function ContextMenuItemComponent(cdr) {
            var _this = this;
            this.cdr = cdr;
            this.select = new i0.EventEmitter();
            this.hide = new i0.EventEmitter();
            this.hideSubitems = debounce(function () {
                _this.visibleSubitems = false;
                _this.cdr.detectChanges();
            });
            this.visibleSubitems = false;
            this.cdr.detach();
        }
        Object.defineProperty(ContextMenuItemComponent.prototype, "block", {
            get: function () { return true; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ContextMenuItemComponent.prototype, "hasSubitems", {
            get: function () { return this.subitems; },
            enumerable: false,
            configurable: true
        });
        ContextMenuItemComponent.prototype.click = function (event) {
            event.stopPropagation();
            this.select.emit();
            this.hide.emit();
        };
        ContextMenuItemComponent.prototype.pointerdown = function (event) {
            event.stopPropagation();
        };
        ContextMenuItemComponent.prototype.wheel = function (event) {
            event.stopPropagation();
        };
        ContextMenuItemComponent.prototype.pointerover = function () {
            this.hideSubitems.cancel();
            this.visibleSubitems = true;
            this.cdr.detectChanges();
        };
        ContextMenuItemComponent.prototype.pointerleave = function () {
            this.hideSubitems.call(this.delay);
            this.cdr.detectChanges();
        };
        return ContextMenuItemComponent;
    }());
    ContextMenuItemComponent.ɵfac = function ContextMenuItemComponent_Factory(t) { return new (t || ContextMenuItemComponent)(i0__namespace.ɵɵdirectiveInject(i0__namespace.ChangeDetectorRef)); };
    ContextMenuItemComponent.ɵcmp = /*@__PURE__*/ i0__namespace.ɵɵdefineComponent({ type: ContextMenuItemComponent, selectors: [["context-menu-item"]], hostAttrs: ["data-testid", "context-menu-item"], hostVars: 4, hostBindings: function ContextMenuItemComponent_HostBindings(rf, ctx) {
            if (rf & 1) {
                i0__namespace.ɵɵlistener("click", function ContextMenuItemComponent_click_HostBindingHandler($event) { return ctx.click($event); })("pointerdown", function ContextMenuItemComponent_pointerdown_HostBindingHandler($event) { return ctx.pointerdown($event); })("wheel", function ContextMenuItemComponent_wheel_HostBindingHandler($event) { return ctx.wheel($event); })("pointerover", function ContextMenuItemComponent_pointerover_HostBindingHandler() { return ctx.pointerover(); })("pointerleave", function ContextMenuItemComponent_pointerleave_HostBindingHandler() { return ctx.pointerleave(); });
            }
            if (rf & 2) {
                i0__namespace.ɵɵclassProp("block", ctx.block)("hasSubitems", ctx.hasSubitems);
            }
        }, inputs: { subitems: "subitems", delay: "delay" }, outputs: { select: "select", hide: "hide" }, ngContentSelectors: _c0, decls: 2, vars: 1, consts: [["class", "subitems", 4, "ngIf"], [1, "subitems"], [3, "delay", "select", "hide", 4, "ngFor", "ngForOf"], [3, "delay", "select", "hide"]], template: function ContextMenuItemComponent_Template(rf, ctx) {
            if (rf & 1) {
                i0__namespace.ɵɵprojectionDef();
                i0__namespace.ɵɵprojection(0);
                i0__namespace.ɵɵtemplate(1, ContextMenuItemComponent_div_1_Template, 2, 1, "div", 0);
            }
            if (rf & 2) {
                i0__namespace.ɵɵadvance(1);
                i0__namespace.ɵɵproperty("ngIf", ctx.subitems && ctx.visibleSubitems);
            }
        }, directives: [i1__namespace.NgIf, i1__namespace.NgForOf, ContextMenuItemComponent], styles: ["@charset \"UTF-8\";.hasSubitems[_nghost-%COMP%]:after{content:\"\\25ba\";position:absolute;opacity:.6;right:5px;top:5px;font-family:initial}.subitems[_ngcontent-%COMP%]{position:absolute;top:0;left:100%;width:120px}", ".block[_ngcontent-%COMP%]{display:block;color:#fff;padding:4px;border-bottom:1px solid rgba(69,103,255,.8);background-color:#6e88ffcc;cursor:pointer;width:100%;position:relative}.block[_ngcontent-%COMP%]:first-child{border-top-left-radius:5px;border-top-right-radius:5px}.block[_ngcontent-%COMP%]:last-child{border-bottom-left-radius:5px;border-bottom-right-radius:5px}.block[_ngcontent-%COMP%]:hover{background-color:#8299ffcc}"] });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(ContextMenuItemComponent, [{
                type: i0.Component,
                args: [{
                        // [component-directive]
                        selector: 'context-menu-item',
                        templateUrl: './item.component.html',
                        styleUrls: ['./item.component.sass', '../../block.sass'],
                        host: {
                            'data-testid': 'context-menu-item'
                        }
                    }]
            }], function () { return [{ type: i0__namespace.ChangeDetectorRef }]; }, { subitems: [{
                    type: i0.Input
                }], delay: [{
                    type: i0.Input
                }], select: [{
                    type: i0.Output
                }], hide: [{
                    type: i0.Output
                }], block: [{
                    type: i0.HostBinding,
                    args: ['class.block']
                }], hasSubitems: [{
                    type: i0.HostBinding,
                    args: ['class.hasSubitems']
                }], click: [{
                    type: i0.HostListener,
                    args: ['click', ['$event']]
                }], pointerdown: [{
                    type: i0.HostListener,
                    args: ['pointerdown', ['$event']]
                }], wheel: [{
                    type: i0.HostListener,
                    args: ['wheel', ['$event']]
                }], pointerover: [{
                    type: i0.HostListener,
                    args: ['pointerover']
                }], pointerleave: [{
                    type: i0.HostListener,
                    args: ['pointerleave']
                }] });
    })();

    function ContextMenuComponent_div_0_Template(rf, ctx) {
        if (rf & 1) {
            var _r3_1 = i0__namespace.ɵɵgetCurrentView();
            i0__namespace.ɵɵelementStart(0, "div", 2);
            i0__namespace.ɵɵelementStart(1, "context-menu-search", 3);
            i0__namespace.ɵɵlistener("update", function ContextMenuComponent_div_0_Template_context_menu_search_update_1_listener($event) { i0__namespace.ɵɵrestoreView(_r3_1); var ctx_r2 = i0__namespace.ɵɵnextContext(); return ctx_r2.setFilter($event); });
            i0__namespace.ɵɵelementEnd();
            i0__namespace.ɵɵelementEnd();
        }
        if (rf & 2) {
            var ctx_r0 = i0__namespace.ɵɵnextContext();
            i0__namespace.ɵɵadvance(1);
            i0__namespace.ɵɵproperty("value", ctx_r0.filter);
        }
    }
    function ContextMenuComponent_context_menu_item_1_Template(rf, ctx) {
        if (rf & 1) {
            var _r6_1 = i0__namespace.ɵɵgetCurrentView();
            i0__namespace.ɵɵelementStart(0, "context-menu-item", 4);
            i0__namespace.ɵɵlistener("select", function ContextMenuComponent_context_menu_item_1_Template_context_menu_item_select_0_listener() { var restoredCtx = i0__namespace.ɵɵrestoreView(_r6_1); var item_r4 = restoredCtx.$implicit; return item_r4.handler(); })("hide", function ContextMenuComponent_context_menu_item_1_Template_context_menu_item_hide_0_listener() { i0__namespace.ɵɵrestoreView(_r6_1); var ctx_r7 = i0__namespace.ɵɵnextContext(); return ctx_r7.onHide(); });
            i0__namespace.ɵɵtext(1);
            i0__namespace.ɵɵelementEnd();
        }
        if (rf & 2) {
            var item_r4 = ctx.$implicit;
            var ctx_r1 = i0__namespace.ɵɵnextContext();
            i0__namespace.ɵɵproperty("delay", ctx_r1.delay)("subitems", item_r4.subitems);
            i0__namespace.ɵɵadvance(1);
            i0__namespace.ɵɵtextInterpolate1(" ", item_r4.label, "\n");
        }
    }
    // [imports]
    var ContextMenuComponent = /** @class */ (function () {
        function ContextMenuComponent(cdr) {
            var _this = this;
            this.cdr = cdr;
            this.filter = '';
            this.hide = debounce(function () {
                _this.onHide();
                _this.cdr.detectChanges();
            });
            this.customAttribute = '';
            this.cdr.detach();
        }
        ContextMenuComponent.prototype.pointerover = function () {
            this.hide.cancel();
            this.cdr.detectChanges();
        };
        ContextMenuComponent.prototype.pointerleave = function () {
            this.hide.call(this.delay);
            this.cdr.detectChanges();
        };
        ContextMenuComponent.prototype.ngOnChanges = function () {
            var _this = this;
            this.cdr.detectChanges();
            requestAnimationFrame(function () { return _this.rendered(); });
        };
        ContextMenuComponent.prototype.setFilter = function (value) {
            this.filter = value;
            this.cdr.detectChanges();
        };
        ContextMenuComponent.prototype.getItems = function () {
            var filterRegexp = new RegExp(this.filter, 'i');
            var filteredList = this.items.filter(function (item) { return (item.label.match(filterRegexp)); });
            return filteredList;
        };
        ContextMenuComponent.prototype.ngOnDestroy = function () {
            if (this.hide)
                this.hide.cancel();
        };
        return ContextMenuComponent;
    }());
    ContextMenuComponent.ɵfac = function ContextMenuComponent_Factory(t) { return new (t || ContextMenuComponent)(i0__namespace.ɵɵdirectiveInject(i0__namespace.ChangeDetectorRef)); };
    ContextMenuComponent.ɵcmp = /*@__PURE__*/ i0__namespace.ɵɵdefineComponent({ type: ContextMenuComponent, selectors: [["ng-component"]], hostAttrs: ["data-testid", "context-menu"], hostVars: 1, hostBindings: function ContextMenuComponent_HostBindings(rf, ctx) {
            if (rf & 1) {
                i0__namespace.ɵɵlistener("mouseover", function ContextMenuComponent_mouseover_HostBindingHandler() { return ctx.pointerover(); })("mouseleave", function ContextMenuComponent_mouseleave_HostBindingHandler() { return ctx.pointerleave(); });
            }
            if (rf & 2) {
                i0__namespace.ɵɵattribute("rete-context-menu", ctx.customAttribute);
            }
        }, inputs: { items: "items", delay: "delay", searchBar: "searchBar", onHide: "onHide", rendered: "rendered" }, features: [i0__namespace.ɵɵNgOnChangesFeature], decls: 2, vars: 2, consts: [["class", "block", 4, "ngIf"], [3, "delay", "subitems", "select", "hide", 4, "ngFor", "ngForOf"], [1, "block"], [3, "value", "update"], [3, "delay", "subitems", "select", "hide"]], template: function ContextMenuComponent_Template(rf, ctx) {
            if (rf & 1) {
                i0__namespace.ɵɵtemplate(0, ContextMenuComponent_div_0_Template, 2, 1, "div", 0);
                i0__namespace.ɵɵtemplate(1, ContextMenuComponent_context_menu_item_1_Template, 2, 3, "context-menu-item", 1);
            }
            if (rf & 2) {
                i0__namespace.ɵɵproperty("ngIf", ctx.searchBar);
                i0__namespace.ɵɵadvance(1);
                i0__namespace.ɵɵproperty("ngForOf", ctx.getItems());
            }
        }, directives: [i1__namespace.NgIf, i1__namespace.NgForOf, ContextMenuSearchComponent, ContextMenuItemComponent], styles: ["[_nghost-%COMP%]{display:block;padding:10px;width:120px;margin-top:-20px;margin-left:-60px}", ".block[_ngcontent-%COMP%]{display:block;color:#fff;padding:4px;border-bottom:1px solid rgba(69,103,255,.8);background-color:#6e88ffcc;cursor:pointer;width:100%;position:relative}.block[_ngcontent-%COMP%]:first-child{border-top-left-radius:5px;border-top-right-radius:5px}.block[_ngcontent-%COMP%]:last-child{border-bottom-left-radius:5px;border-bottom-right-radius:5px}.block[_ngcontent-%COMP%]:hover{background-color:#8299ffcc}"] });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(ContextMenuComponent, [{
                type: i0.Component,
                args: [{
                        // [component-directive]
                        templateUrl: './menu.component.html',
                        styleUrls: ['./menu.component.sass', '../../block.sass'],
                        host: {
                            'data-testid': 'context-menu'
                        }
                    }]
            }], function () { return [{ type: i0__namespace.ChangeDetectorRef }]; }, { items: [{
                    type: i0.Input
                }], delay: [{
                    type: i0.Input
                }], searchBar: [{
                    type: i0.Input
                }], onHide: [{
                    type: i0.Input
                }], rendered: [{
                    type: i0.Input
                }], customAttribute: [{
                    type: i0.HostBinding,
                    args: ['attr.rete-context-menu']
                }], pointerover: [{
                    type: i0.HostListener,
                    args: ['mouseover']
                }], pointerleave: [{
                    type: i0.HostListener,
                    args: ['mouseleave']
                }] });
    })();

    /**
     * Preset for rendering context menu.
     */
    function setup$2(props) {
        var delay = typeof (props === null || props === void 0 ? void 0 : props.delay) === 'undefined' ? 1000 : props.delay;
        return {
            update: function (context) {
                if (context.data.type === 'contextmenu') {
                    return {
                        items: context.data.items,
                        delay: delay,
                        searchBar: context.data.searchBar,
                        onHide: context.data.onHide
                    };
                }
            },
            mount: function (context, plugin) {
                var parent = plugin.parentScope();
                var emit = parent.emit.bind(parent);
                var rendered = function () {
                    emit({ type: 'rendered', data: context.data });
                };
                if (context.data.type === 'contextmenu') {
                    return {
                        key: 'context-menu',
                        component: ContextMenuComponent,
                        props: {
                            items: context.data.items,
                            delay: delay,
                            searchBar: context.data.searchBar,
                            onHide: context.data.onHide,
                            rendered: rendered
                        }
                    };
                }
                return null;
            }
        };
    }

    var index$3 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        setup: setup$2
    });

    function useDrag(translate, getPointer) {
        return {
            start: function (e) {
                var previous = Object.assign({}, getPointer(e));
                function move(moveEvent) {
                    var current = Object.assign({}, getPointer(moveEvent));
                    var dx = current.x - previous.x;
                    var dy = current.y - previous.y;
                    previous = current;
                    translate(dx, dy);
                }
                function up() {
                    window.removeEventListener('pointermove', move);
                    window.removeEventListener('pointerup', up);
                    window.removeEventListener('pointercancel', up);
                }
                window.addEventListener('pointermove', move);
                window.addEventListener('pointerup', up);
                window.addEventListener('pointercancel', up);
            }
        };
    }

    var MiniViewportComponent = /** @class */ (function () {
        function MiniViewportComponent() {
            var _this = this;
            this.drag = useDrag(function (dx, dy) { return _this.onDrag(dx, dy); }, function (e) { return ({ x: e.pageX, y: e.pageY }); });
        }
        Object.defineProperty(MiniViewportComponent.prototype, "styleLeft", {
            get: function () {
                return this.px(this.scale(this.left));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MiniViewportComponent.prototype, "styleTop", {
            get: function () {
                return this.px(this.scale(this.top));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MiniViewportComponent.prototype, "styleWidth", {
            get: function () {
                return this.px(this.scale(this.width));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MiniViewportComponent.prototype, "styleHeight", {
            get: function () {
                return this.px(this.scale(this.height));
            },
            enumerable: false,
            configurable: true
        });
        MiniViewportComponent.prototype.pointerdown = function (event) {
            event.stopPropagation();
            this.drag.start(event);
        };
        MiniViewportComponent.prototype.px = function (value) {
            return value + "px";
        };
        MiniViewportComponent.prototype.scale = function (v) {
            return v * this.containerWidth;
        };
        MiniViewportComponent.prototype.invert = function (v) {
            return v / this.containerWidth;
        };
        MiniViewportComponent.prototype.onDrag = function (dx, dy) {
            this.translate(this.invert(-dx), this.invert(-dy));
        };
        return MiniViewportComponent;
    }());
    MiniViewportComponent.ɵfac = function MiniViewportComponent_Factory(t) { return new (t || MiniViewportComponent)(); };
    MiniViewportComponent.ɵcmp = /*@__PURE__*/ i0__namespace.ɵɵdefineComponent({ type: MiniViewportComponent, selectors: [["minimap-mini-viewport"]], hostAttrs: ["data-testid", "minimap-viewport"], hostVars: 8, hostBindings: function MiniViewportComponent_HostBindings(rf, ctx) {
            if (rf & 1) {
                i0__namespace.ɵɵlistener("pointerdown", function MiniViewportComponent_pointerdown_HostBindingHandler($event) { return ctx.pointerdown($event); });
            }
            if (rf & 2) {
                i0__namespace.ɵɵstyleProp("left", ctx.styleLeft)("top", ctx.styleTop)("width", ctx.styleWidth)("height", ctx.styleHeight);
            }
        }, inputs: { left: "left", top: "top", width: "width", height: "height", containerWidth: "containerWidth", translate: "translate" }, decls: 0, vars: 0, template: function MiniViewportComponent_Template(rf, ctx) { }, styles: ["[_nghost-%COMP%]{display:block;position:absolute;background:rgba(255,251,128,.32);border:1px solid #ffe52b}"] });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(MiniViewportComponent, [{
                type: i0.Component,
                args: [{
                        selector: 'minimap-mini-viewport',
                        templateUrl: './mini-viewport.component.html',
                        styleUrls: ['./mini-viewport.component.sass'],
                        host: {
                            'data-testid': 'minimap-viewport'
                        }
                    }]
            }], null, { left: [{
                    type: i0.Input
                }], top: [{
                    type: i0.Input
                }], width: [{
                    type: i0.Input
                }], height: [{
                    type: i0.Input
                }], containerWidth: [{
                    type: i0.Input
                }], translate: [{
                    type: i0.Input
                }], styleLeft: [{
                    type: i0.HostBinding,
                    args: ['style.left']
                }], styleTop: [{
                    type: i0.HostBinding,
                    args: ['style.top']
                }], styleWidth: [{
                    type: i0.HostBinding,
                    args: ['style.width']
                }], styleHeight: [{
                    type: i0.HostBinding,
                    args: ['style.height']
                }], pointerdown: [{
                    type: i0.HostListener,
                    args: ['pointerdown', ['$event']]
                }] });
    })();

    var MiniNodeComponent = /** @class */ (function () {
        function MiniNodeComponent() {
        }
        Object.defineProperty(MiniNodeComponent.prototype, "styleLeft", {
            get: function () {
                return this.px(this.left);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MiniNodeComponent.prototype, "styleTop", {
            get: function () {
                return this.px(this.top);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MiniNodeComponent.prototype, "styleWidth", {
            get: function () {
                return this.px(this.width);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MiniNodeComponent.prototype, "styleHeight", {
            get: function () {
                return this.px(this.height);
            },
            enumerable: false,
            configurable: true
        });
        MiniNodeComponent.prototype.px = function (value) {
            return value + "px";
        };
        return MiniNodeComponent;
    }());
    MiniNodeComponent.ɵfac = function MiniNodeComponent_Factory(t) { return new (t || MiniNodeComponent)(); };
    MiniNodeComponent.ɵcmp = /*@__PURE__*/ i0__namespace.ɵɵdefineComponent({ type: MiniNodeComponent, selectors: [["minimap-mini-node"]], hostAttrs: ["data-testid", "minimap-node"], hostVars: 8, hostBindings: function MiniNodeComponent_HostBindings(rf, ctx) {
            if (rf & 2) {
                i0__namespace.ɵɵstyleProp("left", ctx.styleLeft)("top", ctx.styleTop)("width", ctx.styleWidth)("height", ctx.styleHeight);
            }
        }, inputs: { left: "left", top: "top", width: "width", height: "height" }, decls: 0, vars: 0, template: function MiniNodeComponent_Template(rf, ctx) { }, styles: ["[_nghost-%COMP%]{display:block;position:absolute;background:rgba(110,136,255,.8);border:1px solid rgba(192,206,212,.6)}"] });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(MiniNodeComponent, [{
                type: i0.Component,
                args: [{
                        selector: 'minimap-mini-node',
                        templateUrl: './mini-node.component.html',
                        styleUrls: ['./mini-node.component.sass'],
                        host: {
                            'data-testid': 'minimap-node'
                        }
                    }]
            }], null, { left: [{
                    type: i0.Input
                }], top: [{
                    type: i0.Input
                }], width: [{
                    type: i0.Input
                }], height: [{
                    type: i0.Input
                }], styleLeft: [{
                    type: i0.HostBinding,
                    args: ['style.left']
                }], styleTop: [{
                    type: i0.HostBinding,
                    args: ['style.top']
                }], styleWidth: [{
                    type: i0.HostBinding,
                    args: ['style.width']
                }], styleHeight: [{
                    type: i0.HostBinding,
                    args: ['style.height']
                }] });
    })();

    function MinimapComponent_minimap_mini_node_0_Template(rf, ctx) {
        if (rf & 1) {
            i0__namespace.ɵɵelement(0, "minimap-mini-node", 2);
        }
        if (rf & 2) {
            var node_r1 = ctx.$implicit;
            var ctx_r0 = i0__namespace.ɵɵnextContext();
            i0__namespace.ɵɵproperty("left", ctx_r0.scale(node_r1.left))("top", ctx_r0.scale(node_r1.top))("width", ctx_r0.scale(node_r1.width))("height", ctx_r0.scale(node_r1.height));
        }
    }
    // [imports]
    var MinimapComponent = /** @class */ (function () {
        function MinimapComponent(el, cdr) {
            this.el = el;
            this.cdr = cdr;
            this.cdr.detach();
        }
        Object.defineProperty(MinimapComponent.prototype, "width", {
            get: function () {
                return this.px(this.size * this.ratio);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MinimapComponent.prototype, "height", {
            get: function () {
                return this.px(this.size);
            },
            enumerable: false,
            configurable: true
        });
        MinimapComponent.prototype.pointerdown = function (event) {
            event.stopPropagation();
            event.preventDefault();
        };
        MinimapComponent.prototype.dblclick = function (event) {
            event.stopPropagation();
            event.preventDefault();
            if (!this.el.nativeElement)
                return;
            var box = this.el.nativeElement.getBoundingClientRect();
            var x = (event.clientX - box.left) / (this.size * this.ratio);
            var y = (event.clientY - box.top) / (this.size * this.ratio);
            this.point(x, y);
        };
        MinimapComponent.prototype.ngOnChanges = function () {
            var _this = this;
            this.cdr.detectChanges();
            requestAnimationFrame(function () { return _this.rendered(); });
        };
        MinimapComponent.prototype.px = function (value) {
            return value + "px";
        };
        MinimapComponent.prototype.scale = function (value) {
            if (!this.el.nativeElement)
                return 0;
            return value * this.el.nativeElement.clientWidth;
        };
        MinimapComponent.prototype.identifyMiniNode = function (_, item) {
            return [item.top, item.left].join('_');
        };
        return MinimapComponent;
    }());
    MinimapComponent.ɵfac = function MinimapComponent_Factory(t) { return new (t || MinimapComponent)(i0__namespace.ɵɵdirectiveInject(i0__namespace.ElementRef), i0__namespace.ɵɵdirectiveInject(i0__namespace.ChangeDetectorRef)); };
    MinimapComponent.ɵcmp = /*@__PURE__*/ i0__namespace.ɵɵdefineComponent({ type: MinimapComponent, selectors: [["ng-component"]], hostAttrs: ["data-testid", "minimap"], hostVars: 4, hostBindings: function MinimapComponent_HostBindings(rf, ctx) {
            if (rf & 1) {
                i0__namespace.ɵɵlistener("pointerdown", function MinimapComponent_pointerdown_HostBindingHandler($event) { return ctx.pointerdown($event); })("dblclick", function MinimapComponent_dblclick_HostBindingHandler($event) { return ctx.dblclick($event); });
            }
            if (rf & 2) {
                i0__namespace.ɵɵstyleProp("width", ctx.width)("height", ctx.height);
            }
        }, inputs: { rendered: "rendered", size: "size", ratio: "ratio", nodes: "nodes", viewport: "viewport", translate: "translate", point: "point" }, features: [i0__namespace.ɵɵNgOnChangesFeature], decls: 2, vars: 8, consts: [[3, "left", "top", "width", "height", 4, "ngFor", "ngForOf", "ngForTrackBy"], [3, "left", "top", "width", "height", "containerWidth", "translate"], [3, "left", "top", "width", "height"]], template: function MinimapComponent_Template(rf, ctx) {
            if (rf & 1) {
                i0__namespace.ɵɵtemplate(0, MinimapComponent_minimap_mini_node_0_Template, 1, 4, "minimap-mini-node", 0);
                i0__namespace.ɵɵelement(1, "minimap-mini-viewport", 1);
            }
            if (rf & 2) {
                i0__namespace.ɵɵproperty("ngForOf", ctx.nodes)("ngForTrackBy", ctx.identifyMiniNode);
                i0__namespace.ɵɵadvance(1);
                i0__namespace.ɵɵproperty("left", ctx.viewport.left)("top", ctx.viewport.top)("width", ctx.viewport.width)("height", ctx.viewport.height)("containerWidth", ctx.el.nativeElement == null ? null : ctx.el.nativeElement.clientWidth)("translate", ctx.translate);
            }
        }, directives: [i1__namespace.NgForOf, MiniViewportComponent, MiniNodeComponent], styles: ["[_nghost-%COMP%]{position:absolute;right:24px;bottom:24px;background:rgba(229,234,239,.65);padding:20px;overflow:hidden;border:1px solid #b1b7ff;border-radius:8px;box-sizing:border-box}"] });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(MinimapComponent, [{
                type: i0.Component,
                args: [{
                        // [component-directive]
                        templateUrl: './minimap.component.html',
                        styleUrls: ['./minimap.component.sass'],
                        host: {
                            'data-testid': 'minimap'
                        }
                    }]
            }], function () { return [{ type: i0__namespace.ElementRef }, { type: i0__namespace.ChangeDetectorRef }]; }, { rendered: [{
                    type: i0.Input
                }], size: [{
                    type: i0.Input
                }], ratio: [{
                    type: i0.Input
                }], nodes: [{
                    type: i0.Input
                }], viewport: [{
                    type: i0.Input
                }], translate: [{
                    type: i0.Input
                }], point: [{
                    type: i0.Input
                }], width: [{
                    type: i0.HostBinding,
                    args: ['style.width']
                }], height: [{
                    type: i0.HostBinding,
                    args: ['style.height']
                }], pointerdown: [{
                    type: i0.HostListener,
                    args: ['pointerdown', ['$event']]
                }], dblclick: [{
                    type: i0.HostListener,
                    args: ['dblclick', ['$event']]
                }] });
    })();

    /**
     * Preset for rendering minimap.
     */
    function setup$1(props) {
        return {
            update: function (context) {
                if (context.data.type === 'minimap') {
                    return {
                        nodes: context.data.nodes,
                        size: (props === null || props === void 0 ? void 0 : props.size) || 200,
                        ratio: context.data.ratio,
                        viewport: context.data.viewport,
                        translate: context.data.translate,
                        point: context.data.point
                    };
                }
                return null;
            },
            mount: function (context, plugin) {
                var parent = plugin.parentScope();
                var emit = parent.emit.bind(parent);
                var rendered = function () {
                    emit({ type: 'rendered', data: context.data });
                };
                if (context.data.type === 'minimap') {
                    return {
                        key: 'rete-minimap',
                        component: MinimapComponent,
                        props: {
                            nodes: context.data.nodes,
                            size: (props === null || props === void 0 ? void 0 : props.size) || 200,
                            ratio: context.data.ratio,
                            viewport: context.data.viewport,
                            translate: context.data.translate,
                            point: context.data.point,
                            rendered: rendered
                        }
                    };
                }
                return null;
            }
        };
    }

    var index$2 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        setup: setup$1
    });

    var pinSize = 20;
    var PinComponent = /** @class */ (function () {
        function PinComponent(cdr) {
            var _this = this;
            this.cdr = cdr;
            this.menu = new i0.EventEmitter();
            this.translate = new i0.EventEmitter();
            this.down = new i0.EventEmitter();
            this.drag = useDrag(function (dx, dy) {
                _this.translate.emit({ dx: dx, dy: dy });
            }, function () { return _this.getPointer(); });
            // this.cdr.detach()
        }
        Object.defineProperty(PinComponent.prototype, "_selected", {
            get: function () {
                return this.selected;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PinComponent.prototype, "top", {
            get: function () {
                return this.position.y - pinSize / 2 + "px";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PinComponent.prototype, "left", {
            get: function () {
                return this.position.x - pinSize / 2 + "px";
            },
            enumerable: false,
            configurable: true
        });
        PinComponent.prototype.pointerdown = function (event) {
            event.stopPropagation();
            event.preventDefault();
            this.drag.start(event);
            this.down.emit();
        };
        PinComponent.prototype.contextmenu = function (event) {
            event.stopPropagation();
            event.preventDefault();
            this.menu.emit();
        };
        PinComponent.prototype.ngOnChanges = function () {
            // this.cdr.detectChanges()
            // requestAnimationFrame(() => this.rendered())
        };
        return PinComponent;
    }());
    PinComponent.ɵfac = function PinComponent_Factory(t) { return new (t || PinComponent)(i0__namespace.ɵɵdirectiveInject(i0__namespace.ChangeDetectorRef)); };
    PinComponent.ɵcmp = /*@__PURE__*/ i0__namespace.ɵɵdefineComponent({ type: PinComponent, selectors: [["reroute-pin"]], hostAttrs: ["data-testid", "pin"], hostVars: 6, hostBindings: function PinComponent_HostBindings(rf, ctx) {
            if (rf & 1) {
                i0__namespace.ɵɵlistener("pointerdown", function PinComponent_pointerdown_HostBindingHandler($event) { return ctx.pointerdown($event); })("contextmenu", function PinComponent_contextmenu_HostBindingHandler($event) { return ctx.contextmenu($event); });
            }
            if (rf & 2) {
                i0__namespace.ɵɵstyleProp("top", ctx.top)("left", ctx.left);
                i0__namespace.ɵɵclassProp("selected", ctx._selected);
            }
        }, inputs: { position: "position", selected: "selected", getPointer: "getPointer" }, outputs: { menu: "menu", translate: "translate", down: "down" }, features: [i0__namespace.ɵɵNgOnChangesFeature], decls: 0, vars: 0, template: function PinComponent_Template(rf, ctx) { }, styles: ["[_nghost-%COMP%]{display:block;width:20px;height:20px;box-sizing:border-box;background:steelblue;border:2px solid white;border-radius:20px;position:absolute}.selected[_nghost-%COMP%]{background:#ffd92c}"] });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(PinComponent, [{
                type: i0.Component,
                args: [{
                        selector: 'reroute-pin',
                        template: '',
                        styleUrls: ['./pin.component.sass'],
                        host: {
                            'data-testid': 'pin'
                        }
                    }]
            }], function () { return [{ type: i0__namespace.ChangeDetectorRef }]; }, { position: [{
                    type: i0.Input
                }], selected: [{
                    type: i0.Input
                }], getPointer: [{
                    type: i0.Input
                }], menu: [{
                    type: i0.Output
                }], translate: [{
                    type: i0.Output
                }], down: [{
                    type: i0.Output
                }], _selected: [{
                    type: i0.HostBinding,
                    args: ['class.selected']
                }], top: [{
                    type: i0.HostBinding,
                    args: ['style.top']
                }], left: [{
                    type: i0.HostBinding,
                    args: ['style.left']
                }], pointerdown: [{
                    type: i0.HostListener,
                    args: ['pointerdown', ['$event']]
                }], contextmenu: [{
                    type: i0.HostListener,
                    args: ['contextmenu', ['$event']]
                }] });
    })();

    function PinsComponent_reroute_pin_0_Template(rf, ctx) {
        if (rf & 1) {
            var _r3_1 = i0__namespace.ɵɵgetCurrentView();
            i0__namespace.ɵɵelementStart(0, "reroute-pin", 1);
            i0__namespace.ɵɵlistener("menu", function PinsComponent_reroute_pin_0_Template_reroute_pin_menu_0_listener() { var restoredCtx = i0__namespace.ɵɵrestoreView(_r3_1); var pin_r1 = restoredCtx.$implicit; var ctx_r2 = i0__namespace.ɵɵnextContext(); return ctx_r2.menu && ctx_r2.menu(pin_r1.id); })("translate", function PinsComponent_reroute_pin_0_Template_reroute_pin_translate_0_listener($event) { var restoredCtx = i0__namespace.ɵɵrestoreView(_r3_1); var pin_r1 = restoredCtx.$implicit; var ctx_r4 = i0__namespace.ɵɵnextContext(); return ctx_r4.translate && ctx_r4.translate(pin_r1.id, $event.dx, $event.dy); })("down", function PinsComponent_reroute_pin_0_Template_reroute_pin_down_0_listener() { var restoredCtx = i0__namespace.ɵɵrestoreView(_r3_1); var pin_r1 = restoredCtx.$implicit; var ctx_r5 = i0__namespace.ɵɵnextContext(); return ctx_r5.down && ctx_r5.down(pin_r1.id); });
            i0__namespace.ɵɵelementEnd();
        }
        if (rf & 2) {
            var pin_r1 = ctx.$implicit;
            var ctx_r0 = i0__namespace.ɵɵnextContext();
            i0__namespace.ɵɵproperty("position", pin_r1.position)("selected", pin_r1.selected)("getPointer", ctx_r0.getPointer);
        }
    }
    // [imports]
    var PinsComponent = /** @class */ (function () {
        function PinsComponent(cdr) {
            this.cdr = cdr;
            this.cdr.detach();
        }
        PinsComponent.prototype.ngOnChanges = function () {
            var _this = this;
            this.cdr.detectChanges();
            requestAnimationFrame(function () { return _this.rendered(); });
        };
        PinsComponent.prototype.track = function (_, item) {
            return item.id;
        };
        return PinsComponent;
    }());
    PinsComponent.ɵfac = function PinsComponent_Factory(t) { return new (t || PinsComponent)(i0__namespace.ɵɵdirectiveInject(i0__namespace.ChangeDetectorRef)); };
    PinsComponent.ɵcmp = /*@__PURE__*/ i0__namespace.ɵɵdefineComponent({ type: PinsComponent, selectors: [["ng-component"]], inputs: { rendered: "rendered", pins: "pins", down: "down", translate: "translate", menu: "menu", getPointer: "getPointer" }, features: [i0__namespace.ɵɵNgOnChangesFeature], decls: 1, vars: 2, consts: [[3, "position", "selected", "getPointer", "menu", "translate", "down", 4, "ngFor", "ngForOf", "ngForTrackBy"], [3, "position", "selected", "getPointer", "menu", "translate", "down"]], template: function PinsComponent_Template(rf, ctx) {
            if (rf & 1) {
                i0__namespace.ɵɵtemplate(0, PinsComponent_reroute_pin_0_Template, 1, 3, "reroute-pin", 0);
            }
            if (rf & 2) {
                i0__namespace.ɵɵproperty("ngForOf", ctx.pins)("ngForTrackBy", ctx.track);
            }
        }, directives: [i1__namespace.NgForOf, PinComponent], encapsulation: 2 });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(PinsComponent, [{
                type: i0.Component,
                args: [{
                        // [component-directive]
                        templateUrl: './pins.component.html'
                    }]
            }], function () { return [{ type: i0__namespace.ChangeDetectorRef }]; }, { rendered: [{
                    type: i0.Input
                }], pins: [{
                    type: i0.Input
                }], down: [{
                    type: i0.Input
                }], translate: [{
                    type: i0.Input
                }], menu: [{
                    type: i0.Input
                }], getPointer: [{
                    type: i0.Input
                }] });
    })();

    /**
     * Preset for rendering pins.
     */
    function setup(props) {
        var getProps = function () { return ({
            menu: (props === null || props === void 0 ? void 0 : props.contextMenu) || (function () { return null; }),
            translate: (props === null || props === void 0 ? void 0 : props.translate) || (function () { return null; }),
            down: (props === null || props === void 0 ? void 0 : props.pointerdown) || (function () { return null; })
        }); };
        return {
            update: function (context) {
                if (context.data.type === 'reroute-pins') {
                    return Object.assign(Object.assign({}, getProps()), { pins: context.data.data.pins });
                }
                return null;
            },
            mount: function (context, plugin) {
                var area = plugin.parentScope(reteAreaPlugin.BaseAreaPlugin);
                var rendered = function () {
                    area.emit({ type: 'rendered', data: context.data });
                };
                if (context.data.type === 'reroute-pins') {
                    return {
                        key: 'rete-reroute',
                        component: PinsComponent,
                        props: Object.assign(Object.assign({}, getProps()), { pins: context.data.data.pins, rendered: rendered, getPointer: function () { return area.area.pointer; } })
                    };
                }
                return null;
            }
        };
    }

    var index$1 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        setup: setup
    });

    var index = /*#__PURE__*/Object.freeze({
        __proto__: null,
        classic: index$4,
        contextMenu: index$3,
        minimap: index$2,
        reroute: index$1
    });

    var ReteModule = /** @class */ (function () {
        function ReteModule() {
        }
        return ReteModule;
    }());
    ReteModule.ɵfac = function ReteModule_Factory(t) { return new (t || ReteModule)(); };
    ReteModule.ɵmod = /*@__PURE__*/ i0__namespace.ɵɵdefineNgModule({ type: ReteModule });
    ReteModule.ɵinj = /*@__PURE__*/ i0__namespace.ɵɵdefineInjector({ imports: [[
                i1.CommonModule
            ]] });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(ReteModule, [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            RefDirective,
                            NodeComponent,
                            ConnectionComponent,
                            ConnectionWrapperComponent,
                            SocketComponent,
                            ControlComponent
                        ],
                        imports: [
                            i1.CommonModule
                        ],
                        exports: [
                            RefDirective,
                            NodeComponent,
                            ConnectionComponent,
                            ConnectionWrapperComponent,
                            SocketComponent,
                            ControlComponent
                        ],
                        entryComponents: [
                            NodeComponent,
                            ConnectionComponent,
                            ConnectionWrapperComponent,
                            SocketComponent,
                            ControlComponent
                        ]
                    }]
            }], null, null);
    })();
    (function () {
        (typeof ngJitMode === "undefined" || ngJitMode) && i0__namespace.ɵɵsetNgModuleScope(ReteModule, { declarations: [RefDirective,
                NodeComponent,
                ConnectionComponent,
                ConnectionWrapperComponent,
                SocketComponent,
                ControlComponent], imports: [i1.CommonModule], exports: [RefDirective,
                NodeComponent,
                ConnectionComponent,
                ConnectionWrapperComponent,
                SocketComponent,
                ControlComponent] });
    })();

    var ReteContextMenuModule = /** @class */ (function () {
        function ReteContextMenuModule() {
        }
        return ReteContextMenuModule;
    }());
    ReteContextMenuModule.ɵfac = function ReteContextMenuModule_Factory(t) { return new (t || ReteContextMenuModule)(); };
    ReteContextMenuModule.ɵmod = /*@__PURE__*/ i0__namespace.ɵɵdefineNgModule({ type: ReteContextMenuModule });
    ReteContextMenuModule.ɵinj = /*@__PURE__*/ i0__namespace.ɵɵdefineInjector({ imports: [[
                i1.CommonModule
            ]] });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(ReteContextMenuModule, [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            ContextMenuComponent,
                            ContextMenuSearchComponent,
                            ContextMenuItemComponent
                        ],
                        imports: [
                            i1.CommonModule
                        ],
                        exports: [
                            ContextMenuComponent,
                            ContextMenuSearchComponent,
                            ContextMenuItemComponent,
                        ],
                        entryComponents: [
                            ContextMenuComponent
                        ]
                    }]
            }], null, null);
    })();
    (function () {
        (typeof ngJitMode === "undefined" || ngJitMode) && i0__namespace.ɵɵsetNgModuleScope(ReteContextMenuModule, { declarations: [ContextMenuComponent,
                ContextMenuSearchComponent,
                ContextMenuItemComponent], imports: [i1.CommonModule], exports: [ContextMenuComponent,
                ContextMenuSearchComponent,
                ContextMenuItemComponent] });
    })();

    var ReteMinimapModule = /** @class */ (function () {
        function ReteMinimapModule() {
        }
        return ReteMinimapModule;
    }());
    ReteMinimapModule.ɵfac = function ReteMinimapModule_Factory(t) { return new (t || ReteMinimapModule)(); };
    ReteMinimapModule.ɵmod = /*@__PURE__*/ i0__namespace.ɵɵdefineNgModule({ type: ReteMinimapModule });
    ReteMinimapModule.ɵinj = /*@__PURE__*/ i0__namespace.ɵɵdefineInjector({ imports: [[
                i1.CommonModule
            ]] });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(ReteMinimapModule, [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            MinimapComponent,
                            MiniViewportComponent,
                            MiniNodeComponent
                        ],
                        imports: [
                            i1.CommonModule
                        ],
                        exports: [
                            MinimapComponent,
                            MiniViewportComponent,
                            MiniNodeComponent
                        ],
                        entryComponents: [
                            MinimapComponent
                        ]
                    }]
            }], null, null);
    })();
    (function () {
        (typeof ngJitMode === "undefined" || ngJitMode) && i0__namespace.ɵɵsetNgModuleScope(ReteMinimapModule, { declarations: [MinimapComponent,
                MiniViewportComponent,
                MiniNodeComponent], imports: [i1.CommonModule], exports: [MinimapComponent,
                MiniViewportComponent,
                MiniNodeComponent] });
    })();

    var ReteRerouteModule = /** @class */ (function () {
        function ReteRerouteModule() {
        }
        return ReteRerouteModule;
    }());
    ReteRerouteModule.ɵfac = function ReteRerouteModule_Factory(t) { return new (t || ReteRerouteModule)(); };
    ReteRerouteModule.ɵmod = /*@__PURE__*/ i0__namespace.ɵɵdefineNgModule({ type: ReteRerouteModule });
    ReteRerouteModule.ɵinj = /*@__PURE__*/ i0__namespace.ɵɵdefineInjector({ imports: [[
                i1.CommonModule
            ]] });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(ReteRerouteModule, [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            PinsComponent,
                            PinComponent,
                        ],
                        imports: [
                            i1.CommonModule
                        ],
                        exports: [
                            PinsComponent,
                            PinComponent,
                        ],
                        entryComponents: [
                            PinsComponent
                        ]
                    }]
            }], null, null);
    })();
    (function () {
        (typeof ngJitMode === "undefined" || ngJitMode) && i0__namespace.ɵɵsetNgModuleScope(ReteRerouteModule, { declarations: [PinsComponent,
                PinComponent], imports: [i1.CommonModule], exports: [PinsComponent,
                PinComponent] });
    })();

    function reflect(obj) {
        if (typeof obj !== 'object' || obj === null) {
            return obj;
        }
        return new Proxy(obj, {
            get: function (target, prop) {
                return target[prop];
            },
            set: function (target, prop, value) {
                target[prop] = value;
                return true;
            },
            has: function (target, prop) { return prop in target; },
            deleteProperty: function (target, prop) { return delete target[prop]; },
            ownKeys: function (target) { return Reflect.ownKeys(target); }
        });
    }

    function getRenderer() {
        var elements$1 = new WeakMap();
        return {
            get: function (element) {
                return elements$1.get(element);
            },
            mount: function (element, key, component, injector, props) {
                // LIMITATION: If an element is remounted with the same identifier, the component cannot be replaced
                var CustomElement = customElements.get(key);
                if (!CustomElement) {
                    CustomElement = elements.createCustomElement(component, { injector: injector });
                    customElements.define(key, CustomElement);
                }
                var ngElement = new CustomElement(injector);
                Object.keys(props).forEach(function (key) {
                    ngElement[key] = props[key];
                });
                element.appendChild(ngElement);
                elements$1.set(element, { key: key, ngElement: ngElement });
            },
            update: function (_a, props) {
                var ngElement = _a.ngElement;
                Object.keys(props).forEach(function (key) {
                    ngElement.ngElementStrategy.setInputValue(key, reflect(props[key]));
                });
            },
            unmount: function (element) {
                var existing = elements$1.get(element);
                if (existing) {
                    existing.ngElement.remove();
                    elements$1.delete(element);
                }
            }
        };
    }
    /**
     * Angular plugin. Renders nodes, connections and other elements using React.
     * @priority 9
     * @emits connectionpath
     * @listens render
     * @listens unmount
     */
    var AngularPlugin = /** @class */ (function (_super) {
        __extends(AngularPlugin, _super);
        /**
         * @constructor
         * @param params Plugin properties
         * @param params.injector Angular's Injector instance
         */
        function AngularPlugin(params) {
            var _this = _super.call(this, 'angular-render') || this;
            _this.params = params;
            _this.presets = [];
            _this.owners = new WeakMap();
            _this.renderer = getRenderer();
            _this.addPipe(function (context) {
                if (!context || typeof context !== 'object' || !('type' in context))
                    return context;
                if (context.type === 'unmount') {
                    _this.unmount(context.data.element);
                }
                else if (context.type === 'render') {
                    if ('filled' in context.data && context.data.filled) {
                        return context;
                    }
                    if (_this.mount(context.data.element, context)) {
                        return Object.assign(Object.assign({}, context), { data: Object.assign(Object.assign({}, context.data), { filled: true }) });
                    }
                }
                return context;
            });
            return _this;
        }
        AngularPlugin.prototype.setParent = function (scope) {
            var _this = this;
            _super.prototype.setParent.call(this, scope);
            this.presets.forEach(function (preset) {
                if (preset.attach)
                    preset.attach(_this);
            });
        };
        AngularPlugin.prototype.unmount = function (element) {
            this.owners.delete(element);
            this.renderer.unmount(element);
        };
        AngularPlugin.prototype.mount = function (element, context) {
            var e_1, _a;
            var _this = this;
            var existing = this.renderer.get(element);
            if (existing) {
                this.presets.forEach(function (preset) {
                    if (_this.owners.get(element) !== preset)
                        return;
                    var result = preset.update(context, _this);
                    if (result) {
                        _this.renderer.update(existing, result);
                    }
                });
                return true;
            }
            try {
                for (var _b = __values(this.presets), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var preset = _c.value;
                    var result = preset.mount(context, this);
                    if (!result)
                        continue;
                    var key = result.key, component = result.component, props = result.props;
                    this.renderer.mount(element, key, component, this.params.injector, props);
                    this.owners.set(element, preset);
                    return true;
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return;
        };
        /**
         * Adds a preset to the plugin.
         * @param preset Preset that can render nodes, connections and other elements.
         */
        AngularPlugin.prototype.addPreset = function (preset) {
            var local = preset;
            if (local.attach)
                local.attach(this);
            this.presets.push(local);
        };
        return AngularPlugin;
    }(rete.Scope));

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AngularPlugin = AngularPlugin;
    exports.ConnectionComponent = ConnectionComponent;
    exports.ConnectionWrapperComponent = ConnectionWrapperComponent;
    exports.ContextMenuComponent = ContextMenuComponent;
    exports.ContextMenuItemComponent = ContextMenuItemComponent;
    exports.ContextMenuSearchComponent = ContextMenuSearchComponent;
    exports.ControlComponent = ControlComponent;
    exports.MiniNodeComponent = MiniNodeComponent;
    exports.MiniViewportComponent = MiniViewportComponent;
    exports.MinimapComponent = MinimapComponent;
    exports.NodeComponent = NodeComponent;
    exports.PinComponent = PinComponent;
    exports.PinsComponent = PinsComponent;
    exports.Presets = index;
    exports.RefDirective = RefDirective;
    exports.ReteContextMenuModule = ReteContextMenuModule;
    exports.ReteMinimapModule = ReteMinimapModule;
    exports.ReteModule = ReteModule;
    exports.ReteRerouteModule = ReteRerouteModule;
    exports.SocketComponent = SocketComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=rete-angular-plugin-ng12.umd.js.map
