import { OnChanges, SimpleChanges, ChangeDetectorRef } from '@angular/core';
import { ClassicPreset } from 'rete';
export declare class ControlComponent<T extends 'text' | 'number'> implements OnChanges {
    private cdr;
    data: ClassicPreset.InputControl<T>;
    rendered: any;
    pointerdown(event: any): void;
    constructor(cdr: ChangeDetectorRef);
    ngOnChanges(changes: SimpleChanges): void;
    onChange(e: Event): void;
}
