import { ChangeDetectorRef, EventEmitter } from '@angular/core';
import { Item } from '../../types';
export declare class ContextMenuItemComponent {
    private cdr;
    subitems?: Item[];
    delay: number;
    select: EventEmitter<void>;
    hide: EventEmitter<void>;
    get block(): boolean;
    get hasSubitems(): Item[];
    click(event: MouseEvent): void;
    pointerdown(event: PointerEvent): void;
    wheel(event: MouseEvent): void;
    hideSubitems: {
        timeout: number;
        cancel(): void;
        call(delay: number): void;
    };
    visibleSubitems: boolean;
    pointerover(): void;
    pointerleave(): void;
    constructor(cdr: ChangeDetectorRef);
}
